/* ** */

#include "ircd_includes.h"
#include "commands.h"
//#include "cmds.h"
//#include "../lib/confparse/configparse.h"

// RCSID("$Id: commands.c,v 1.20 2001/10/02 01:40:35 cbehrens Exp $");

#ifdef TS5
#define TS_CURRENT  5   /* current TS protocol version */
#else
#define TS_CURRENT  3   /* current TS protocol version */
#endif

#ifdef TS5_ONLY
#define TS_MIN      5   /* minimum supported TS protocol version */
#else
#define TS_MIN      3   /* minimum supported TS protocol version */
#endif


static char *months[] =
{
        "January",
        "February",
        "March",
        "April",
    	"May",
        "June",
        "July",
        "August",
    	"September",
        "October",
        "November",
        "December"
};

static char *weekdays[] =
{
        "Sunday",
        "Monday",
        "Tuesday",
        "Wednesday",
    	"Thursday",
        "Friday",
        "Saturday"
};


#if 0
static int _lusers_send(IRCD_CLIENT *pptr, char *pattern, int sendcounter);                                                
static int _motd_send(IRCD_CLIENT *pptr);
#endif

// static void _sendnick(IRCD_CLIENT *cptr, IRCD_CLIENT *acptr);
static void _count_servers_and_users(IRCD_CLIENT *acptr, int *numservers, int *numusers);
static void send_capabilities(IRCD_CLIENT *cptr, int send_zip);
static void _send_servers_recurs(IRCD_CLIENT *lptr, IRCD_CLIENT *cptr);
static char *datestr(int thetime, char *buf);
static void _sendnick(IRCD_CLIENT *cptr, IRCD_CLIENT *acptr);


/* FIXME: add more. 
 * 	'ipaddr' == new nick format(?)
 * 	'zip'	 == zipped links
 * 	'ext'	 == uh..
 */

static IRCD_CAPAB _ircd_capabs[] =
{
	{ IRCD_CAPAB_VALUE_NOQUITSTORM, "QS", 0 },
	{ 0, NULL, 0 }
};


#ifdef KLINES
static char *_reason_fix(char *reason)
{
	static char	reasonbuf[401];	/* reason can only be 200 long, so.. */
	char *dptr = reasonbuf;
	char *sptr = reason;

	for(;*sptr;)
	{
		if (*sptr == '\"')
			*dptr++ = '\\';
		*dptr++ = *sptr++;
	}
	*dptr = '\0';
	return reasonbuf;
}
#endif

#if 0
int m_gnotice(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	char 		*message = ircd_nextarg(&args, NEXTARG_FLAGS_LASTARG);
	IRCD_CLIENT 	*cptr;

	if(!IsAnOper(pptr) && !IsServer(pptr) && MyClient(pptr))
	{
		send_prefix_to_client(meptr, pptr, IRCD_REPLY(ERR_NOPRIVILEGES, pptr->name));
		return 3;
	}

	if(!(pptr->c_oline_flags & OLINE_FLAGS_CANGNOTICE) && MyClient(pptr))
	{
		send_prefix_to_client(meptr, pptr, "NOTICE %s :You are not allowed to GNOTICE.", pptr->name);
		return 3;
	}

	for(cptr=Locals;cptr;cptr=cptr->c_lo_next)
	{
		if(!IsServer(cptr)) 
		{
			if (IsClient(cptr))
				send_prefix_to_client(pptr, cptr, "NOTICE %s :[%s@%s] %s", cptr->name, pptr->name, NetName, message);
			else
				send_to_client(cptr, ":%s NOTICE %s :[%s@%s]) %s", prefix, cptr->name, pptr->name, NetName, message);
		}
	}

	send_to_servers(IsServer(lptr) ? lptr : NULL, ":%s GNOTICE :%s", prefix, message);

	return 3;
}
#endif

int _hunt_server(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *format, int server, char *prefix, char *argptr)
{
	char		theargs[512];
	char		*args = theargs;
	char		*argss[10];
	int			numargs;
	IRCD_CLIENT	*acptr;

	if ((--server < 0) || (server > 7))
		return HUNTED_ISME;

	support_strncpy(theargs, argptr, sizeof(theargs));

	for(numargs=0;numargs < 8;numargs++)
		if (!(argss[numargs] = ircd_nextarg(&args, 0)))
		{
			while(numargs < 8)
				argss[numargs++] = NULL;
			break;
		}

	if (!argss[server] || !match(meptr->name, argss[server]) ||
			!match(argss[server], meptr->name))
		return HUNTED_ISME;
	if ((acptr = hash_find_client_incl_hm(argss[server])) != NULL)
		if (acptr->c_from == pptr->c_from && !IsLocal(acptr))
			acptr = NULL;
	if (!acptr)
	{
		for(acptr=*Servers;acptr;acptr=acptr->c_os_next)
		{
			if ((acptr->c_from == pptr->c_from) && IsLocal(acptr))
				continue;
			if (!match(acptr->name, argss[server]) ||
					!match(argss[server], acptr->name))
				break;
		}
	}
	if (acptr)
	{
		if (IsMe(acptr) || MyClient(acptr))
			return HUNTED_ISME;
		if (match(acptr->name, argss[server]))
			argss[server] = acptr->name;
		send_to_client(acptr, format, prefix, argss[0],
				argss[1], argss[2], argss[3], argss[4],
				argss[5], argss[6], argss[7]);
		return HUNTED_PASS;
	}
	send_prefix_to_client(meptr, pptr, IRCD_REPLY(ERR_NOSUCHSERVER, pptr->name),
			argss[server]);
	return HUNTED_NOSUCH;
}

#if 0
static IRCD_MODE *_ircdmode_create(IRCD_MODE **ircdmodes, IRCD_MODE **lastircdmode)
{
	IRCD_MODE	*nircdmode;


	nircdmode = (IRCD_MODE *)MyMalloc(sizeof(IRCD_MODE));
	if (!*lastircdmode)
		*ircdmodes = nircdmode;
	else
		(*lastircdmode)->next = nircdmode;
	return (*lastircdmode = nircdmode);
}

static void _ircdmode_free(IRCD_MODE **bucket)
{
	IRCD_MODE	*nextp;

	for(;*bucket;*bucket = nextp)
	{
		nextp = (*bucket)->next;
		MyFree(*bucket);
	}
}
#endif

static char *datestr(int thetime, char *buf)
{
	struct tm	gmbuf;
	struct tm	*tmptr;
	time_t		temptime;
	char		plusminus;
	int			minswest;

	if (!thetime)
		thetime = (int)time(NULL);
	temptime = (time_t)thetime;
	tmptr = gmtime(&temptime);
	if (tmptr)
		memcpy(&gmbuf, tmptr, sizeof(struct tm));
	else
	{
		strcpy(buf, "Error getting date");
		return buf;
	}
	tmptr = localtime(&temptime);

	if (tmptr->tm_yday == gmbuf.tm_yday)
		minswest = (gmbuf.tm_hour - tmptr->tm_hour) * 60 +
			(gmbuf.tm_min - tmptr->tm_min);
	else if (tmptr->tm_yday > gmbuf.tm_yday)
		minswest = (gmbuf.tm_hour - (tmptr->tm_hour + 24)) * 60;
	else
		minswest = ((gmbuf.tm_hour + 24) - tmptr->tm_hour) * 60;

	if (minswest > 0)
		plusminus = '-';
	else
	{
		plusminus = '+';
		minswest = -minswest;
	}

	sprintf(buf, "%s %s %d %04d -- %02d:%02d %c%02d:%02d",
		weekdays[tmptr->tm_wday], months[tmptr->tm_mon], tmptr->tm_mday,
		tmptr->tm_year + 1900, tmptr->tm_hour, tmptr->tm_min,
		plusminus, minswest/60, minswest%60);
	return buf;
}
#ifdef KLINES
static char *_cluster(char *hostname, int *ip_or_host)
{
	static char		result[HOSTLEN+10];
	int				len;

	if (!hostname || !*hostname)
		return NULL;

	len = strlen(hostname);

	if (len > HOSTLEN)
		return NULL;

	if (isdigit(*(hostname+len-1)))
	{
		char	*tmp = result + len - 1;

		if (ip_or_host)
			*ip_or_host = 0;

		strcpy(result, hostname);
		for(;tmp >= result;tmp--)
		{
			if (*tmp == '.')
				break;
		}
		if (tmp < result)
			return result;
		*(tmp+1) = '*';
		*(tmp+2) = '\0';
	}
	else
	{
		char	*tmp = len <= 3 ? hostname : hostname + len - 3;
		int     num = 2;
		char	*host = hostname + len - 1;

		if (ip_or_host)
			*ip_or_host = 1;

		if (strcasecmp(tmp, "com") && strcasecmp(tmp, "edu") &&
				(support_stristr(hostname, "com") ||
					support_stristr(hostname, "edu")))
			num = 3;

		for(;host>=hostname;host--)
		{
			if ((*host == '.') && (!--num))
				break;
		}
		if (host < hostname)
			host = hostname;
		*result = '*';
		strcpy(result+1, *host == '.' ? host + 1 : host);
	}
	return result;
}
#endif
static void _send_servers_recurs(IRCD_CLIENT *lptr, IRCD_CLIENT *cptr)
{
	char			cnamebuf1[CLIENTNAMESIZE];
	IRCD_CLIENT		*acptr;

	for(acptr=cptr->c_servers;acptr;acptr=acptr->c_u_next)
	{
		if (acptr->c_from == lptr) /* will be true for acptr == lptr too */
			continue;
		if (!match(conf_myname_for_link(meptr->name, lptr->c_hostmask,
					cnamebuf1), acptr->name))
			continue;
		send_prefix_to_client(acptr->c_servptr, lptr, "SERVER %s %d :%s",
			acptr->name, acptr->c_hopcount+1, acptr->ircname);
		_send_servers_recurs(lptr, acptr);
	}
}

static void _count_servers_and_users(IRCD_CLIENT *acptr, int *numservers, int *numusers)
{
	IRCD_CLIENT	*u;

	for(u=acptr->c_servers;u;u=u->c_u_next)
	{
		_count_servers_and_users(u, numservers, numusers);
	}
	for(u=acptr->c_users;u;u=u->c_u_next)
		(*numusers)++;
	(*numservers)++;
}

static void send_capabilities(IRCD_CLIENT *lptr, int send_zip)
{
	IRCD_CAPAB	*cptr;
	char		buffer[256];
	char		*ptr;
	char		*sptr;
	char		*dptr;

	ptr = dptr = buffer;
	for(cptr=_ircd_capabs;cptr->name;cptr++)
	{
		if ((cptr->value == IRCD_CAPAB_VALUE_ZIP) && !send_zip)
			continue;
		if (ptr != buffer)
		{
			*ptr++ = ' ';
			dptr++;
		}
		sptr = cptr->name;
		while(((dptr - buffer) < sizeof(buffer)) && (*dptr = *sptr++))
			dptr++;
		if ((dptr - buffer) == sizeof(buffer))
		{
			*(ptr-1) = '\0'; /* -1 to kill the space that was added */
			send_to_client(lptr, "CAPAB :%s", buffer);
			dptr = ptr = buffer;
			sptr = cptr->name;
			while((*dptr = *sptr++))
				dptr++;
		}
		ptr = dptr;
	}
	if (ptr != buffer)
	{
		*ptr = '\0';
		send_to_client(lptr, "CAPAB :%s", buffer);
	}
}

/*
** :prefix SERVER servername serverinfo/hopcount serverinfo
*/
int m_server(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	char			*servername = ircd_nextarg(&args, 0);
	char			*hopcount = ircd_nextarg(&args, 0);
	char			*serverinfo = ircd_nextarg(&args, 0);
	char			cnamebuf1[CLIENTNAMESIZE];
	int				hc = 0;
	IRCD_CLIENT		*acptr;
	SERVLINK		*sl;
	IRCD_CLASSENTRY	*classptr;
	int				ret;

	if(IsReg(lptr))
		return 3;
	
	if (!servername)
	{
		client_del(meptr, lptr, "No servername");
		return -1;
	}
	if (!serverinfo || !hopcount || !(hc = atoi(hopcount)))
	{
		serverinfo = hopcount;
		hopcount = NULL;
	}
	if (!(lptr->c_flags & CLIENT_FLAGS_SCONNECT)
			&& !IsServer(lptr) &&
					(*lptr->name || (lptr->c_flags & CLIENT_FLAGS_GOTUSER)))
	{
		if (*lptr->name)
			send_prefix_to_client(meptr, lptr, IRCD_REPLY(ERR_ALREADYREGISTRED,
					lptr->name));
		return 3;
	}
	else
	{
		char	clean_host[(HOSTLEN*2)+1];
		char	*sptr = servername;
		char	*dptr = clean_host;
		int		gotdot = 0;
		int		bogus = 0;
		int		len = 0;

		while(*sptr)
		{
			if (*sptr < ' ')
			{
				bogus++;
				*dptr++ = '^';
				*dptr++ = (*(sptr++) + 'A');
			}
			else if (*sptr > '~')
			{
				bogus++;
				*dptr++ = '.';
				sptr++;
			}
			else if ((*dptr++ = *sptr++) == '.')
				gotdot++;
			if (++len == HOSTLEN)
			{
				servername[len] = '\0';
				break;
			}
		}
		*dptr = '\0';
		if (!gotdot || bogus)
		{
			send_to_opers("Bogus server name (%s) from %s",
				clean_host, ircd_clientname(lptr, 1, cnamebuf1));
			if (IsUnknown(lptr))
			{
				client_del(meptr, lptr, "Invalid servername");
				return -1;
			}
			return 3;
		}
	}

	if ((acptr = hash_find_client_incl_hm(servername)) != NULL)
	{
		char			cnamebuf2[CLIENTNAMESIZE];
		IRCD_CLIENT		*bcptr;

		bcptr = (lptr->c_firsttime > acptr->c_from->c_firsttime) ?
					lptr : acptr->c_from;
		send_to_client(bcptr, "ERROR :Server %s already exists", servername);
		if (bcptr == lptr)
		{
			send_to_opers("Link %s cancelled, server %s already exists",
					ircd_clientname(bcptr, 1, cnamebuf1), servername);
			client_del(meptr, bcptr, "Server Exists");
			return -1;
		}
		send_to_opers("Link %s cancelled, server %s reintroduced by %s",
				ircd_clientname(bcptr, 1, cnamebuf1), servername,
				ircd_clientname(lptr, 1, cnamebuf2));
		client_del(meptr, bcptr, "Server Exists");
	}

	if (IsServer(lptr))
	{
		IRCD_CLIENT		*bcptr;

		if (!serverinfo)
			serverinfo = "*Unknown*";

		/* check leaf + hub stuff */

		acptr = (IRCD_CLIENT *)MyMalloc(sizeof(IRCD_CLIENT));
		acptr->c_type = CLIENT_TYPE_SERVER;
		acptr->c_from = lptr;
		acptr->c_hopcount = hc;
		acptr->c_lasttime = acptr->c_firsttime = Now;
		acptr->c_rem_ipaddr = -1;
		acptr->c_rem_port = 0;
		support_strncpy(acptr->name, servername, sizeof(acptr->name));
		support_strncpy(acptr->ircname, serverinfo, sizeof(acptr->ircname));
		if (++Globalinfo->g_servers > Globalinfo->g_maxservers)
		{
			Globalinfo->g_maxservers = Globalinfo->g_servers;
			Globalinfo->g_maxserverstime = Now;
		}
		hash_add_client(acptr);
		acptr->c_servptr = pptr;
		add_client_to_ulist(&(pptr->c_servers), acptr);
		add_client_to_oslist(Servers, acptr);
		for(bcptr=*Servers;bcptr;bcptr=bcptr->c_os_next)
		{
			if ((bcptr == meptr) || (bcptr == lptr) || !IsLocal(bcptr))
				continue;
			if (!match(conf_myname_for_link(meptr->name,
						bcptr->c_hostmask, cnamebuf1), acptr->name))
				continue;
			send_prefix_to_client(pptr, bcptr, "SERVER %s %d :%s",
					acptr->name, hc+1, acptr->ircname);
		}

		/* we're gonna bypass a lot of that bursting bullshit with remote servers here. i dont need to harass
		 * them as they link, so we can skip that part peacefully.. */
#if 0
		Globalinfo->g_serversbursting++;
		CliSetSentEOB(acptr);
		send_prefix_to_client(meptr, acptr, "PING %s :%s",
						meptr->name, acptr->name);
#else
		CliSetGotEOB(acptr);
#endif
		send_to_flag(CLIENT_NFLAGS_CONNECTS, NULL,
			"Server %s[%s] being introduced by %s",
				acptr->name, acptr->ircname, pptr->name);
		return 3;
	}

	if (serverinfo == NULL || !*serverinfo)
	{
		char	exitbuf[512];

		sprintf(exitbuf, "No server info specified for %s", servername);
		client_del(meptr, lptr, exitbuf);
		return -1;
	}

#ifdef NO_HUB
	if(Globalinfo->m_servers == 1)
	{
		send_to_opers("Link %s cancelled, I'm not a HUB",
				ircd_clientname(lptr, 1, cnamebuf1));
		client_del(meptr, lptr, "I'm a leaf, not a hub");
		return -1;
	}
#else
	if (!vars_value_get_bynum(IRCD_VAR_HUB) && Globalinfo->m_servers == 1)
	{
		send_to_opers("Link %s cancelled, I'm not a HUB",
			ircd_clientname(lptr, 1, cnamebuf1));
		client_del(meptr, lptr, "I'm a leaf, not a hub");
		return -1;
	}
#endif

	/* new local server */
	if (!*lptr->c_passwd)
	{
		send_to_opers("Link %s cancelled, no password given",
				ircd_clientname(lptr, 1, cnamebuf1));
		client_del(meptr, lptr, "No password given");
		return -1;
	}
	if (!DoesTS(lptr))
	{
		send_to_opers("Link %s dropped, non-TS server",
				ircd_clientname(lptr, 1, cnamebuf1));
		client_del(meptr, lptr, "non-TS server");
		return -1;
	}

	if (lptr->c_flags & CLIENT_FLAGS_SCONNECT)
	{
		if (strcasecmp(lptr->name, servername))
		{
			send_to_opers("Link %s dropped, name mismatch -- %s",
				ircd_clientname(lptr, 1, cnamebuf1), servername);
			client_del(meptr, lptr, "servername mismatch");
			return -1;
		}
	}
	else
		strcpy(lptr->name, servername);

	lptr->c_hopcount = hc;

	sl = servlink_find(servername, lptr);
	if (!sl)
	{
		send_to_opers("Received unauthorized connection from %s.",
				ircd_clientname(lptr, 1, cnamebuf1));
		client_del(meptr, lptr, "No C/N conf lines");
		return -1;
	}

	if (!sl->npasswd || !*sl->npasswd || !*lptr->c_passwd ||
				strcmp(sl->npasswd, lptr->c_passwd))
	{
		send_to_opers("Access denied (passwd mismatch) %s",
			ircd_clientname(lptr, 1, cnamebuf1));
		client_del(meptr, lptr, "Access denied (passwd mismatch)");
		sl->tryconnecttime = 0;
		return -1;
	}

	if (sl->classptr)
		classptr = (IRCD_CLASSENTRY *)sl->classptr;
	else
	{
		ret = class_find(&(_ircd_conf.classes), sl->classname, &classptr);
		if (ret < 0) /* hrm...*/
		{
			send_to_opers("Class %s not found in conf -- denying %s",
				sl->classname, ircd_clientname(lptr, 1, cnamebuf1));
			client_del(meptr, lptr, "Configuration Error -- Class not found");
			sl->tryconnecttime = 0;
			return -1;
	    }
		sl->classptr = (void *)classptr;
	}

	sl->tryconnecttime = 0;
	sl->lastconnect = Now;

    add_client_to_cllist(&(classptr->clients), lptr);
	classptr->num_on++;
    lptr->c_class = classptr;
    lptr->c_maxsendq = -1; /*  we'll reset this below */
    lptr->c_pingfreq = classptr->pingfreq;

	BZERO(lptr->c_passwd, sizeof(lptr->c_passwd));

	lptr->c_hostmask = sl->hostmask;

	if (!(lptr->c_flags & CLIENT_FLAGS_SCONNECT))
	{
		if (sl->cpasswd && *sl->cpasswd)
			send_to_client(lptr, "PASS %s :TS", sl->cpasswd);
		send_capabilities(lptr, 0);
		send_to_client(lptr, "SERVER %s 1 :%s",
			conf_myname_for_link(meptr->name, lptr->c_hostmask, cnamebuf1),
			meptr->ircname);
	}


	send_to_client(lptr, "SVINFO %d %d %d :%d", TS_CURRENT, TS_MIN,
			Globalinfo->m_servers ? 1 : 0, Now);

	lptr->c_type = CLIENT_TYPE_SERVER;
	support_strncpy(lptr->ircname, serverinfo, sizeof(lptr->ircname));
	queue_resize(&(lptr->c_queue_in), 32*1024);
	queue_resize(&(lptr->c_queue_out), 32*1024);
	add_client_to_oslist(Servers, lptr);
	hash_add_client(lptr);
	lptr->c_servptr = meptr;
#if 0
	add_client_to_slist(&(meptr->c_servers), lptr);
#else
	add_client_to_ulist(&(meptr->c_servers), lptr);
#endif

	if (!lptr->c_connectby)
	{
		lptr->c_connectby = MyMalloc(CLIENTNAMESIZE);
		sprintf(lptr->c_connectby, "Remote!Connect@%s", meptr->name);
	}

	send_to_opers("Link with %s (TS%s) established.",
			ircd_clientname(lptr, 1, cnamebuf1),
			(is_ulined(ircd_clientname(lptr, 1, cnamebuf1))) ? ")(U" : "");

	send_to_flag(CLIENT_NFLAGS_CONNECTS, NULL,
			"Server %s being introduced locally", lptr->name);

	ret = Recvbuffersize;
	setsockopt(lptr->c_connptr->fdlistinfo.fd, SOL_SOCKET, SO_RCVBUF, (char *)&ret, sizeof(ret));
	ret = Sendbuffersize;
	setsockopt(lptr->c_connptr->fdlistinfo.fd, SOL_SOCKET, SO_SNDBUF, (char *)&ret, sizeof(ret));

	if (++Globalinfo->g_servers > Globalinfo->g_maxservers)
	{
		Globalinfo->g_maxservers = Globalinfo->g_servers;
		Globalinfo->g_maxserverstime = Now;
	}
	if (++Globalinfo->m_servers > Globalinfo->m_maxservers)
	{
		Globalinfo->m_maxservers = Globalinfo->m_servers;
		Globalinfo->m_maxserverstime = Now;
	}
	if (Globalinfo->m_clients + Globalinfo->m_servers > Globalinfo->m_maxconn)
	{
		Globalinfo->m_maxconn = Globalinfo->m_clients + Globalinfo->m_servers;
		Globalinfo->m_maxconntime = Now;
	}

	/* send new server to my connected servers. */
	for(acptr=meptr->c_servers;acptr;acptr=acptr->c_u_next)
	{
		if (acptr == lptr)
			continue;
		if (!match(conf_myname_for_link(meptr->name,
						acptr->c_hostmask, cnamebuf1), lptr->name))
			continue;
		/* FIXME: send the right hops */
		send_prefix_to_client(meptr, acptr, "SERVER %s %d :%s",
				lptr->name, acptr->c_hopcount+1, lptr->ircname);
	}

	/* send existing servers to new server. */
	_send_servers_recurs(lptr, meptr);

#if 0
	for(acptr=meptr->c_servers;acptr;acptr=acptr->c_u_next)
	{
		if (acptr->c_from == lptr)
			continue;
		if (!match(conf_myname_for_link(meptr->name, lptr->c_hostmask,
					cnamebuf1), acptr->name))
		{
			_send_servers_recurs(lptr, acptr);
			continue;
		}
		send_prefix_to_client(acptr->c_servptr, lptr, "SERVER %s %d :%s",
				acptr->name, acptr->c_hopcount+1, acptr->ircname);
		_send_servers_recurs(lptr, acptr);
	}
#endif

	{
		static char		nickissent = 1;
		IRCD_CHANNEL	*chptr;
		IRCD_CLIENTLIST	*clptr;

		nickissent = 3 - nickissent;

		for(chptr=Channels;chptr;chptr=chptr->next)
		{
			for(clptr=chptr->members;clptr;clptr=clptr->next)
			{
				if (clptr->cptr->c_nicksent != nickissent)
				{
					clptr->cptr->c_nicksent = nickissent;
					if (clptr->cptr->c_from != lptr)
						_sendnick(lptr, clptr->cptr);
				}
			}
			_send_channel_modes(lptr, chptr);
		}

		/*
		** also send out those that are not on any channel
		*/
		for (acptr=*Clients;acptr;acptr=acptr->c_os_next)
		{
            if (acptr->c_nicksent != nickissent)
            {
                acptr->c_nicksent = nickissent;
                if (acptr->c_from != lptr)
                    _sendnick(lptr, acptr);
            }
		}
		/* Local Opers aren't in the above Clients list */
		for (acptr=*Opers;acptr;acptr=acptr->c_os_next)
		{
            if (acptr->c_nicksent != nickissent)
            {
                acptr->c_nicksent = nickissent;
                if (acptr->c_from != lptr)
                    _sendnick(lptr, acptr);
            }
		}
#if 0
		/* send out the glines */
		{
			IRCD_DENY 	*dptr;

			for(dptr=Denies;dptr;dptr=dptr->next)
				if(dptr->ban != NULL)
					send_to_client(lptr, ":%s GLINE +%s %s %i 0 :%s",
								meptr->name, glptr->ban, glptr->oper, glptr->expire, glptr->reason);
		}
#endif
		
		Globalinfo->g_serversbursting++;
        	CliSetSentEOB(lptr);
		send_prefix_to_client(meptr, lptr, "PING %s :%s",
						meptr->name, lptr->name);


		/* FIXME: still need to send out away messages, and perhaps i should break up the burst? */
	}

#if 0
/*
	for when we allow unlimited sendq during burst...
      but, we'll also need to somehow check that a remote
     server is bursting, before this stuff will work
*/
     
	if ((lptr->c_queue_out.queue_size + 1000000) > lptr->c_class->maxsendq)
		lptr->c_maxsendq = lptr->c_queue_out.queue_size + 1000000;
	else
		lptr->c_maxsendq = lptr->c_class->maxsendq;

#else
		lptr->c_maxsendq = lptr->c_class->maxsendq;
#endif

	return 3;
}


int m_version(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	if (!IsServer(lptr) && !IsReg(lptr))
	{
		send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_VERSION,
				pptr->name), VERSION, "", meptr->name, "http://darkircd.sourceforge.net");
		client_del(pptr, pptr, "Leaving");
		return -1;
	}

	if (_hunt_server(lptr, pptr, ":%s VERSION :%s", 1, prefix, args) == HUNTED_ISME)
		send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_VERSION,
				pptr->name), VERSION, "", meptr->name, "http://darkircd.sourceforge.net");
	return 3;
}

int m_squit(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	char			*server = ircd_nextarg(&args, 0);
	char			*comment = ircd_nextarg(&args, NEXTARG_FLAGS_LASTARG);
	char			cnamebuf[CLIENTNAMESIZE];
	IRCD_CLIENT		*acptr;

	if (!IsAnOper(pptr) && !IsServer(pptr))
	{
		send_prefix_to_client(meptr, pptr,
			IRCD_REPLY(ERR_NOPRIVILEGES, pptr->name));
		return 3;
	}

	if (server && *server)
	{
		if ((*server == '*') && IsServer(lptr))
		{
			if (!mycmp(server, conf_myname_for_link(meptr->name,
						lptr->c_hostmask, cnamebuf)))
				server = lptr->name;
		}

		for(acptr=*Servers;acptr;acptr=acptr->c_os_next)
			if (!match(server, acptr->name))
				break;
		if (acptr && IsMe(acptr))
		{
			acptr = lptr;
			server = lptr->name;
		}
	}
	else
	{
		server = lptr->name;
		acptr = lptr;
	}

	if (!acptr || IsClient(acptr))
	{
		if (IsClient(pptr))
			send_prefix_to_client(meptr, pptr,
				IRCD_REPLY(ERR_NOSUCHSERVER, pptr->name), server);
		return 3;
	}

	if ((pptr->c_umodes & CLIENT_UMODES_LOCOP) && !IsLocal(acptr))
	{
		send_prefix_to_client(meptr, pptr,
				IRCD_REPLY(ERR_NOPRIVILEGES, pptr->name));
		return 3;
	}

	if (!comment || !*comment)
		comment = lptr->name;

	if (IsLocal(acptr) && IsServer(lptr))
	{
		send_wallops_to_flag(CLIENT_NFLAGS_SWALLOPS, NULL, meptr,
			"Received SQUIT %s from %s (%s)",
			server, ircd_clientname(pptr, 0, cnamebuf), comment);
		send_to_servers(NULL, ":%s WALLOPS :Received SQUIT %s from %s (%s)",
			meptr->name,
			server, ircd_clientname(pptr, 0, cnamebuf), comment);
	}
	else if (IsLocal(acptr))
	{
		send_to_opers("Received SQUIT %s from %s (%s)",
			acptr->name, ircd_clientname(pptr, 0, cnamebuf), comment);
	}
	acptr->c_flags |= CLIENT_FLAGS_KILLED;
	client_del(pptr, acptr, comment);
	return (acptr == lptr) ? -1 : 3;
}

int m_info(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	static int	ratenum = 0;
	static int	ratetime = 0;
#if 0
	char		numbuf[256];
#endif

	if (!IsServer(lptr) && !IsReg(pptr))
	{
		send_prefix_to_client(meptr, pptr, IRCD_REPLY(ERR_NOTREGISTERED, NULL));
		return 3;
	}

	if (_hunt_server(lptr, pptr, ":%s INFO :%s", 1, prefix, args) != HUNTED_ISME)
	{
		return 6; /* remote info requests from local clients */
	}

	if (!IsLocal(pptr) && !IsAnOper(pptr) && ircd_ratelimit(pptr, &ratenum, &ratetime, (int)vars_value_get_bynum(IRCD_VAR_RATELIMIT_INFO_NUM), (int)vars_value_get_bynum(IRCD_VAR_RATELIMIT_TIME)))
		return 0;
#if 0
	send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_INFO, pptr->name), "");
	send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_INFO, pptr->name), "Welcome to csircd (CodeStud Ircd) -- http://www.codestud.com/ircd");
	send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_INFO, pptr->name), "");
	send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_INFO, pptr->name), "This server was mostly written by Chris Behrens <cbehrens@codestud.com>");
	send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_INFO, pptr->name), "between 1998 and 1999 to create a more efficient client server for EFnet.");
	send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_INFO, pptr->name), "");
	send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_INFO, pptr->name), "Other contributors include:");
	send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_INFO, pptr->name), "Thomas Helvey");
	send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_INFO, pptr->name), "Fred Jacobs");
	send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_INFO, pptr->name), "Richard Steenbergen");
	send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_INFO, pptr->name), "...and I'm sure others that I've forgotten.");
	send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_INFO, pptr->name), "");
	sprintf(numbuf, "Current TS Version: %d", TS_CURRENT);
	send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_INFO, pptr->name), numbuf);
	sprintf(numbuf, "Minimum TS Version: %d", TS_MIN);
	send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_INFO, pptr->name), numbuf);
	send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_INFO, pptr->name), "");
	send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_INFO, pptr->name), "Please send comments, bug reports, patches, etc to ircd@codestud.com.");
	send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_INFO, pptr->name), "");
	send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_INFO, pptr->name), " - Chris");
#endif
	send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_INFO, pptr->name), "darkircd-1.0b1, based off of csircd(www.codestud.com) and available at http://darkircd.sf.net/");
	send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_INFO, pptr->name), "	- nothing here yet! thanks to comstud(who wrote csircd, the base i happily leeched off of),");
	send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_INFO, pptr->name), "	  and to Hagabard, Abner, PreZ, Raider, and everyone i know on ETG and Hashmark..");
	send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_INFO, pptr->name), "");
	send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_INFO, pptr->name), "	-myr (adam@lackofdiscipline.com) [send complaints/whatever to that address]");
	send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_ENDOFINFO, pptr->name));

	return 3;
}

/*
** m_links
**  parv[0] = sender prefix
**  parv[1] = servername mask
** or
**  parv[0] = sender prefix
**  parv[1] = server to query
**      parv[2] = servername mask
*/
int m_links(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	char	argssave[512];
	char	*servername;
	char	*mask;
	IRCD_CLIENT	*acptr;
	
	if (!IsServer(lptr) && !IsReg(pptr))
	{
		send_prefix_to_client(meptr, pptr, IRCD_REPLY(ERR_NOTREGISTERED, NULL));
		return 3;
	}

	if (args)
		support_strncpy(argssave, args, sizeof(argssave));

	mask = ircd_nextarg(&args, 0);
	servername = ircd_nextarg(&args, 0);
#if 0
	if (servername && *servername)
	{
		if (_hunt_server(lptr, pptr, ":%s LINKS %s :%s", 1, prefix, argssave) != HUNTED_ISME)
			return 3;
		mask = servername;
	}
#endif

	if (!mask || !*mask)
		mask = NULL;

	for(acptr=*Servers;acptr;acptr=acptr->c_os_next)
	{
		if (!mask || !match(mask, acptr->name))
		{
			send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_LINKS,
					pptr->name), acptr->name, acptr->c_servptr->name,
					acptr->c_hopcount, *acptr->ircname ? acptr->ircname :
					"(Unknown Location)");
		}
	}
	send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_ENDOFLINKS, pptr->name),
			mask ? mask : "*");
	return 3;
}

int m_map(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	char tree[20] = ""; /* possible of 20 hops with 20 servers each... heh */
	IRCD_CLIENT *sptr;
	int branches, hops;

	if(!IsReg(pptr))
	{
		 send_prefix_to_client(meptr, pptr, IRCD_REPLY(ERR_NOTREGISTERED, NULL));
		 return 3;
	}

	if(!MyClient(pptr) || IsServer(pptr))
		return 3;
	
	branches = hops = 1;

	for(sptr=*Servers;sptr;sptr=sptr->c_os_next)
	{
		if(!IsMe(sptr) && sptr->c_hopcount == 0)
			hops = 1;
		else
			hops = sptr->c_hopcount;

		branches = hops;

		for(;branches;branches--)
			tree[branches] = ' ';

		tree[0] = ' ';
		tree[hops+1] = '\0';

		send_prefix_to_client(meptr, pptr, "NOTICE %s :[%i] %s> %s %s", pptr->name, hops, 
						tree, sptr->name, is_ulined(sptr->name) ? "(ulined)" : "");
	}

	return 3;
}

int m_stats(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	IRCD_CLIENT		*sptr;
	IRCD_CLIENT		*acptr;
	IRCD_LISTENER	*liptr;
	char			cnamebuf[CLIENTNAMESIZE];
	char			*thing;
	char			*server;
	char			*rest;
	OLINE			*oline;
	SERVLINK		*servlink;
	int				now;
	CONFHOSTIPENTRY	*chentry;
	IRCD_CLASSENTRY	**ceptr;
	int				i;
	static char 	LFormat[] = "%d %s %s %u %u %u %u %u :%u";
	static int		ratenum = 0;
	static int		ratetime = 0;

	if (!IsServer(lptr) && !IsReg(pptr))
	{
		send_prefix_to_client(meptr, pptr, IRCD_REPLY(ERR_NOTREGISTERED, NULL));
		return 3;
	}

	if (_hunt_server(lptr, pptr, ":%s STATS %s :%s", 2, prefix, args) != HUNTED_ISME)
	{
		return 6; /* remote queries are penalized more */
	}

	thing = ircd_nextarg(&args, 0);
	server = ircd_nextarg(&args, 0);
	rest = ircd_nextarg(&args, 0);

	if (!thing || !*thing)
	{
		send_prefix_to_client(meptr, pptr,
					IRCD_REPLY(ERR_NEEDMOREPARAMS, pptr->name), "STATS");
		return 3;
	}

	send_to_flag(CLIENT_NFLAGS_STATSNOTICES, NULL,
			"STATS %s%c requested by %s (%s@%s) [%s]",
			*thing < ' ' ? "^" : "",
			(*thing) < ' ' ? (*thing)+0x40 : *thing,
			pptr->name, pptr->username, pptr->hostname,
			pptr->servername);

#define Meg 1024
#define Gig (Meg*1024)
#define Tera (Gig*1024)
#define IsMeg(x) (x>Meg)
#define IsGig(x) (x>Gig)
#define IsTera(x) (x>Tera)
#define ByteString(x) (IsTera(x) ? "Tb " : \
            IsGig(x) ? "Gig" : \
            IsMeg(x) ? "Meg" : \
            "KB ")
#define ByteConvert(x) (IsTera(x) ? (float)((float)x/(float)Tera) : \
            IsGig(x) ? (float)((float)x/(float)Gig) : \
            IsMeg(x) ? (float)((float)x/(float)Meg) : \
            (float)x)

	acptr = NULL;
	if (server && *server)
	{
		acptr = hash_find_chasing(server);
	}

	if ((*thing == 'L') || (*thing == 'l'))
	{
		if (!IsAnOper(pptr) && (!acptr || !IsClient(acptr)))
			*thing = '?';
	}

	if ((*thing != '?') && !IsLocal(pptr) && !IsAnOper(pptr) && ircd_ratelimit(pptr, &ratenum, &ratetime, (int)vars_value_get_bynum(IRCD_VAR_RATELIMIT_STATS_NUM), (int)vars_value_get_bynum(IRCD_VAR_RATELIMIT_TIME)))
		return 0;

	if (!strcasecmp(thing, "rate"))
	{
		int itotal = Globalinfo->bw_c_incoming_rate + Globalinfo->bw_s_incoming_rate;
		int ototal = Globalinfo->bw_c_outgoing_rate + Globalinfo->bw_s_outgoing_rate;

		send_prefix_to_client(meptr, pptr,
				"%d %s :Current Bandwidth Statistics (in bytes/second):",
					RPL_STATSDEBUG, pptr->name);
		send_prefix_to_client(meptr, pptr,
				"%d %s :Clients --  Incoming: %6i     Outgoing: %6i",
					RPL_STATSDEBUG, pptr->name, Globalinfo->bw_c_incoming_rate,
					Globalinfo->bw_c_outgoing_rate);
		send_prefix_to_client(meptr, pptr,
				"%d %s :Servers --  Incoming: %6i     Outgoing: %6i",
					RPL_STATSDEBUG, pptr->name,
					Globalinfo->bw_s_incoming_rate,
					Globalinfo->bw_s_outgoing_rate);
		send_prefix_to_client(meptr, pptr,
				"%d %s :  Total --  Incoming: %6i     Outgoing: %6i",
					RPL_STATSDEBUG, pptr->name, itotal, ototal);
	}
	else if (!strcasecmp(thing, "uline"))
	{
		IRCD_ULINE      **Ulines = &(_ircd_conf.ulines);
                IRCD_ULINE      *ul;

                for(ul=*Ulines;ul;ul=ul->next)
                {
                        send_prefix_to_client(meptr, pptr, "%d %s :%s",
                                                RPL_STATSULINE, pptr->name, ul->servername);
                }
	}
        else if (!strcasecmp(thing, "whois"))
        {
                IRCD_WL      **wlevels = &(_ircd_conf.wlevels);
                IRCD_WL      *wl;
                                   
                for(wl=*wlevels;wl;wl=wl->next)
                {
                        send_prefix_to_client(meptr, pptr, "%d %s :(%i) %s",
                                                RPL_STATSDEBUG, pptr->name, wl->number, wl->text);
                }
        }    
	else switch(*thing)
	{
		case '?':
			for(sptr=*Servers;sptr;sptr=sptr->c_os_next)
			{
				if (!IsLocal(sptr))
					continue;
				send_prefix_to_client(meptr, pptr, LFormat,
						RPL_STATSLINKINFO, pptr->name,
						IsAnOper(pptr) ? ircd_clientname(sptr, 1, cnamebuf) :
						ircd_clientname(sptr, 0, cnamebuf),
						sptr->c_queue_out.queue_size,
						sptr->c_send_msg,
						sptr->c_send_kbytes,
						sptr->c_recv_msg,
						sptr->c_recv_kbytes,
						Now - sptr->c_firsttime);
			}
			break;
		case 'C':
		case 'c':
			for(servlink=_ircd_conf.servers;servlink;servlink=servlink->next)
			{
				static char hidden[] = "127.0.0.1";
				char		flagsbuf[64];
				char		*ptr;
				char		*hname;

				ptr = flagsbuf;

				if (servlink->flags & SERVLINK_FLAGS_AUTOCONN)
				{
					if (ptr != flagsbuf)
						*ptr++ = ' ';
					ptr += sprintf(ptr, "autoconn");
				}
#if 0
				else if (servlink->flags & ... )
				{
					if (ptr != flagsbuf)
						*ptr++ = ' ';
					ptr += sprintf(ptr, "newflag");
				}
#endif

				*ptr = '\0';

				if ( /* !IsAnOper(pptr) && */
						(servlink->flags & SERVLINK_FLAGS_HIDEHOSTNAME))
					hname = hidden;
				else
					hname = servlink->hostname;

				send_prefix_to_client(meptr, pptr,
						IRCD_REPLY(RPL_STATSCLINE, pptr->name),
						'C', servlink->username ? servlink->username : "*",
						hname, servlink->servername,
						servlink->port, servlink->classname, flagsbuf);
				send_prefix_to_client(meptr, pptr,
						IRCD_REPLY(RPL_STATSNLINE, pptr->name),
						'N', servlink->username ? servlink->username : "*",
						hname, servlink->servername,
						servlink->hostmask, servlink->classname, flagsbuf);
			}
			break;
		case 'D':
		case 'd':
		case 'G':
		case 'g':
			{
				char 		typename[10];
				IRCD_DENY 	*dptr;

				for(dptr=Denies;dptr;dptr=dptr->next)
				{
					if(dptr->type & DENY_TYPE_AKILL)
						strcpy(typename, "AKILL");
					else if(dptr->type & DENY_TYPE_NICK)
						strcpy(typename, "NICK");
					else if(dptr->type & DENY_TYPE_CHANNEL)
						strcpy(typename, "CHANNEL");
					else /* filters out 'null' denies too */
						continue;

					send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_STATSDENY, pptr->name),
								*thing, dptr->mask, typename, (dptr->type & DENY_TYPE_LOCAL) ? 'L' : '-', (dptr->type & DENY_TYPE_PERM) ? 'P' : '-',
									dptr->when, dptr->expire, dptr->oper, dptr->reason);
				}
			}
			break;
		case 'H':
		case 'h':
			for(servlink=_ircd_conf.servers;servlink;servlink=servlink->next)
			{
				IRCD_STRINGLIST *stptr;

				for(stptr=servlink->hubs;stptr;stptr=stptr->next)
				{
					send_prefix_to_client(meptr, pptr,
						IRCD_REPLY(RPL_STATSHLINE, pptr->name),
						'H', stptr->string, servlink->servername, 0, -1);
				}
				for(stptr=servlink->leafs;stptr;stptr=stptr->next)
				{
					send_prefix_to_client(meptr, pptr,
						IRCD_REPLY(RPL_STATSLLINE, pptr->name),
						'L', stptr->string, servlink->servername, 0, -1);
				}
			}
			break;
		case 'I':
		case 'i':
			for(chentry=_ircd_conf.allow.conf_all;chentry;chentry=chentry->ch_next)
			{
				char *iname = NULL;
				char *hname = NULL;
				IRCD_CLASSENTRY	*classptr;

				if (chentry->classptr)
					classptr = (IRCD_CLASSENTRY *)chentry->classptr;
				else
				{
					int ret = class_find(&(_ircd_conf.classes),
							chentry->classname, &classptr);
					if (ret < 0)
						classptr = NULL;
					else
						chentry->classptr = (void *)classptr;
				}

				if (classptr && (classptr->flags & CLASS_FLAGS_HIDEHOSTNAME))
					continue;

				if (chentry->ipstring)
				{
					if (chentry->username)
					{
						iname = (char *)MyMalloc(strlen(chentry->username)+
										strlen(chentry->ipstring) + 2);
						sprintf(iname, "%s@%s", chentry->username,
										chentry->ipstring);
					}
					else
						iname = MyStrdup(chentry->ipstring);
				}
				if (chentry->hostname)
				{
					if (chentry->username)
					{
						hname = (char *)MyMalloc(strlen(chentry->username)+
										strlen(chentry->hostname) + 2);
						sprintf(hname, "%s@%s", chentry->username,
										chentry->hostname);
					}
					else
						hname = MyStrdup(chentry->hostname);
				}

				send_prefix_to_client(meptr, pptr,
					IRCD_REPLY(RPL_STATSILINE, pptr->name),
					'I', iname ? iname : "X", hname ? hname : "X",
					0, chentry->classname);

				if (iname)
					MyFree(iname);
				if (hname)
					MyFree(hname);
			}
			break;
#ifdef KLINES
		case 'K':
		case 'k':
		{
			char *user = NULL;
			char *host = NULL;
			static char _star[] = "*";
			int	numfound = 0;

			if (!IsOper(pptr) && (!rest || !*rest))
			{
				user = pptr->username;
				host = pptr->hostname;
			}
			else if (rest && *rest)
			{
				acptr = hash_find_client(rest);
				if (!acptr || IsServer(acptr))
				{
					user = host = rest;
					while(*host && (*host != '@'))
						host++;
					if (!*host)
					{
						host = rest;
						user = _star;
					}
					else
					{
						*host++ = '\0';
						if (!*host)
							host = _star;
					}
					if (!*user)
						user = _star;
				}
				else
				{
					user = acptr->username;
					host = acptr->hostname;
				}
			}
			for(chentry=_ircd_conf.deny.conf_all;chentry;chentry=chentry->ch_next)
			{
				char *iname = NULL;
				char *hname = NULL;

				if (chentry->expires && (chentry->expires < Now))
					continue;

				if (user)
				{
					if (chentry->username &&
							match(chentry->username, user) &&
							match(user, chentry->username))
						continue;
					if (!(((chentry->ipstring &&
						(!match(chentry->ipstring, host) ||
								!match(host, chentry->ipstring))) ||
						(chentry->hostname &&
						(!match(chentry->hostname, host) ||
								!match(host, chentry->hostname))))))
						continue;
				}
				if (chentry->ipstring)
				{
					if (chentry->username)
					{
						iname = (char *)MyMalloc(strlen(chentry->username)+
										strlen(chentry->ipstring) + 2);
						sprintf(iname, "%s@%s", chentry->username,
										chentry->ipstring);
					}
					else
						iname = MyStrdup(chentry->ipstring);
				}
				if (chentry->hostname)
				{
					if (chentry->username)
					{
						hname = (char *)MyMalloc(strlen(chentry->username)+
										strlen(chentry->hostname) + 2);
						sprintf(hname, "%s@%s", chentry->username,
										chentry->hostname);
					}
					else
						hname = MyStrdup(chentry->hostname);
				}

				numfound++;
				send_prefix_to_client(meptr, pptr,
					IRCD_REPLY(RPL_STATSKLINE, pptr->name),
					'K', iname ? iname : "X",
					hname ? hname : "X", chentry->expires,
					chentry->flags,
					chentry->data ? chentry->data : "*");

				if (iname)
					MyFree(iname);
				if (hname)
					MyFree(hname);

				if (user && (numfound == 100))
				{
					send_prefix_to_client(meptr, pptr,
						"NOTICE %s :Maximum of 100 bans reached -- stopping request.",
						pptr->name);
					break;
				}
			}
			if (!numfound)
			{
				send_prefix_to_client(meptr, pptr,
					"NOTICE %s :No bans %s%s%s%s%s%sfound",
					pptr->name,
					user ? "matching" : "", user ? " " : "",
					user ? user : "", user ? "@": "",
					user ? host : "", user ? " " : "");
			}
		}
			break;
#endif
		case 'L':
		case 'l':
			if (acptr && IsClient(acptr))
			{
				if (IsLocal(acptr))
					send_prefix_to_client(meptr, pptr, LFormat,
						RPL_STATSLINKINFO, pptr->name,
						*thing == 'L' ? ircd_clientname(acptr, 1, cnamebuf):
						ircd_clientname(acptr, 0, cnamebuf),
						acptr->c_queue_out.queue_size,
						acptr->c_send_msg, acptr->c_send_kbytes,
						acptr->c_recv_msg, acptr->c_recv_kbytes,
						Now - acptr->c_firsttime);
				break;
			}
			/* IsAnOper(pptr) is TRUE because of check above switch() */

			for(liptr=_ircd_conf.listeners;liptr;liptr=liptr->l_next)
			{
				sprintf(cnamebuf, "%s[*@%s.%d]",
						meptr->name,
						liptr->l_ipstring, liptr->l_port);
				send_prefix_to_client(meptr, pptr, LFormat,
					RPL_STATSLINKINFO, pptr->name, cnamebuf, 0, 0, 0, 0, 0,
					Now - liptr->l_firsttime);
			}
			for(acptr=Locals;acptr;acptr=acptr->c_lo_next)
			{
				if (!IsClient(acptr) && !IsServer(acptr))
					continue;
				send_prefix_to_client(meptr, pptr, LFormat,
					RPL_STATSLINKINFO, pptr->name,
					*thing == 'L' ? ircd_clientname(acptr, 1, cnamebuf):
					ircd_clientname(acptr, 0, cnamebuf),
					acptr->c_queue_out.queue_size,
					acptr->c_send_msg, acptr->c_send_kbytes,
					acptr->c_recv_msg, acptr->c_recv_kbytes,
					Now - acptr->c_firsttime);
			}

			break;
		case 'O':
		case 'o':
			for(oline=_ircd_conf.olines;oline;oline=oline->next)
			{
				send_prefix_to_client(meptr, pptr,
					IRCD_REPLY(RPL_STATSOLINE, pptr->name),
					oline->flags & OLINE_FLAGS_LOCAL ? 'o' : 'O', 
#if 0
					oline->username ? oline->username : "*",
					oline->hostname,
#else
					"*", "127.0.0.1",
#endif
					oline->name, 0, oline->classname);
			}
			break;
		case 'U':
		case 'u':
			now = Now - meptr->c_firsttime;
			send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_STATSUPTIME,
					pptr->name), now/86400, (now/3600)%24, (now/60)%60,
					now % 60);
			break;

		case 'Y':
		case 'y':
			for(ceptr=_ircd_conf.classes.entries,i=_ircd_conf.classes.num;i--;ceptr++)
			{
				send_prefix_to_client(meptr, pptr,
					IRCD_REPLY(RPL_STATSYLINE, pptr->name),
					'Y', (*ceptr)->classname, (*ceptr)->pingfreq,
					(*ceptr)->connfreq, (*ceptr)->maxclients,
					(*ceptr)->maxsendq, (*ceptr)->uhlimit,
					(*ceptr)->hlimit,
					(*ceptr)->floodnum, (*ceptr)->floodtime,
					(*ceptr)->floodexit, (*ceptr)->ipaddr_rate_num,
					(*ceptr)->ipaddr_rate_time);
			}
			break;
		case 'p':
		case 'P':
			i = 0;
			for(acptr=*Opers;acptr;acptr=acptr->c_os_next)
			{
				if (!IsLocal(acptr))
					continue;
				i++;
				send_prefix_to_client(meptr, pptr,
						"%d %s :[%c] %s (%s@%s) idle %is",
						RPL_STATSDEBUG, pptr->name,
						IsOper(acptr) ? 'O' : 'o',
						acptr->name, acptr->username,
						acptr->hostname, Now - acptr->c_idletime);
			}
			if (!i)
				send_prefix_to_client(meptr, pptr, "%d %s :No opers found",
						RPL_STATSDEBUG, pptr->name);
			break;
		case 'Q':
		case 'q':
			if (IsAnOper(pptr))
			{
				STRINGDENY	*sd;

				for(sd=_ircd_conf.nickname_denies;sd;sd=sd->next)
				{
					send_prefix_to_client(meptr, pptr,
						IRCD_REPLY(RPL_STATSQLINE, pptr->name),
						sd->name, "-", "-", sd->expires,
						sd->flags, sd->reason);
				}
				for(sd=_ircd_conf.channel_denies;sd;sd=sd->next)
				{
					send_prefix_to_client(meptr, pptr,
						IRCD_REPLY(RPL_STATSQLINE, pptr->name),
						sd->name, "-", "-", sd->expires,
						sd->flags, sd->reason);
				}
			}
			break;
		case 'X':
		case 'x':
			if (IsAnOper(pptr))
			{
				STRINGDENY	*sd;

				for(sd=_ircd_conf.ircname_denies;sd;sd=sd->next)
				{
					send_prefix_to_client(meptr, pptr,
						IRCD_REPLY(RPL_STATSXLINE, pptr->name),
						sd->name, sd->expires,
						sd->flags, sd->reason);
				}
			}
			break;
		case 'Z':
		case 'z':
		{
			unsigned int total_usage = 0;
			unsigned int iphash_num_nethash;
			unsigned int iphash_num_ips;
			unsigned int iphash_size_nethash;
			unsigned int whowas_num;
			unsigned int whowas_memory;
			unsigned int whowas_array_size;
			int i;
			IRCD_CLIENT	*list = Locals;
			IRCD_CLIENT *nextacptr;
			unsigned int lo_num = 0;
			unsigned int cl_num = 0;
			unsigned int extra_mem = 0;
			unsigned int ch_num = 0;
			unsigned int ch_mem = 0;
			unsigned int ban_num = 0;
			unsigned int ban_mem = 0;
			IRCD_CHANNEL	*chptr;

			iphash_count_memory(&iphash_num_nethash, &iphash_num_ips,
				&iphash_size_nethash);
			total_usage += iphash_num_nethash * sizeof(IRCD_NETHASH);
			total_usage += iphash_num_ips * sizeof(IRCD_IPENTRY);
			total_usage += iphash_size_nethash;

			send_prefix_to_client(meptr, pptr,
				"%d %s :IPHASH: Array: %i NetEntries: %i(%i) IPEntries: %i(%i)",
				RPL_STATSDEBUG, pptr->name,
				iphash_size_nethash, iphash_num_nethash,
				iphash_num_nethash * sizeof(IRCD_NETHASH),
				iphash_num_ips, iphash_num_ips * sizeof(IRCD_IPENTRY));
			whowas_count_memory(&whowas_num, &whowas_memory, &whowas_array_size);
			total_usage += whowas_memory + whowas_array_size;

			send_prefix_to_client(meptr, pptr,
				"%d %s :Whowas: Array: %i Entries: %i(%i)",
				RPL_STATSDEBUG, pptr->name,
				whowas_array_size, whowas_num, whowas_memory);

			for(i=0;i<4;i++)
			{
				if (i==1)
					list = *Clients;
				else if (i==2)
					list = *Opers;
				else if (i==3)
					list = *Servers;
				for(acptr=list;acptr;acptr=nextacptr)
				{
					if (list == Locals)
					{
						nextacptr = acptr->c_lo_next;
						lo_num++;
					}
					else
					{
						nextacptr = acptr->c_os_next;
						if (IsLocal(acptr))
							continue; /* already done */
						if (IsClient(acptr))
							cl_num++;
						else
							lo_num++;
					}
					if (acptr->c_away)
						extra_mem += strlen(acptr->c_away)+1;
					if (IsLocal(acptr) && acptr->c_connectby)
						extra_mem += strlen(acptr->c_connectby)+1;
					if (acptr->c_invites_list)
					{
						IRCD_INVITE	*iptr;
						for(iptr=acptr->c_invites_list;iptr;iptr=iptr->next)
							extra_mem += sizeof(IRCD_INVITE) + strlen(iptr->channel) + 1;
					}
					if (acptr->c_channels)
					{
						IRCD_CHANNELLIST	*chlptr;
						for(chlptr=acptr->c_channels;chlptr;chlptr=chlptr->next)
							extra_mem += sizeof(IRCD_CHANNELLIST) + sizeof(IRCD_CLIENTLIST);
					}
				}
			}
			total_usage += lo_num * sizeof(IRCD_CLIENT);
			total_usage += cl_num * offsetof(IRCD_CLIENT, c_auth_ptr);
			total_usage += extra_mem;
			total_usage += sizeof(Fds);
			send_prefix_to_client(meptr, pptr,
				"%d %s :Clients: Local: %i(%i) Remote: %i(%i) Extra: %i  Fds: %i",
				RPL_STATSDEBUG, pptr->name,
				lo_num, lo_num*sizeof(IRCD_CLIENT), cl_num,
				cl_num * offsetof(IRCD_CLIENT, c_auth_ptr),
				extra_mem, sizeof(Fds));
			for(chptr=Channels;chptr;chptr=chptr->next)
			{
				ch_num++;
				ch_mem += strlen(chptr->name);
				if (chptr->key)
					extra_mem += strlen(chptr->key) + 1;
				if (chptr->topic)
					extra_mem += strlen(chptr->topic) + 1;
				if (chptr->topic_who)
					extra_mem += strlen(chptr->topic_who) + 1;
				if (chptr->bans)
				{
					IRCD_BAN	*b;
					for(b=chptr->bans;b;b=b->next)
					{
						ban_num++;
						if (b->firstpart)
							ban_mem += strlen(b->firstpart) + 1;
						if (b->banstring)
							ban_mem += strlen(b->banstring) + 1;
						if (b->who)
							ban_mem += strlen(b->who) + 1;
					}
				}
			}
			total_usage += ch_mem + ban_mem + (ban_num * sizeof(IRCD_BAN));
			total_usage += extra_mem;
			send_prefix_to_client(meptr, pptr,
				"%d %s :Channels: %i(%i) Bans: %i(%i) Extra: %i",
				RPL_STATSDEBUG, pptr->name, ch_num,
				ch_mem, ban_num, ban_mem + (ban_num * sizeof(IRCD_BAN)),
				extra_mem);
			send_prefix_to_client(meptr, pptr,
				"%d %s :Total Usage: %i",
				RPL_STATSDEBUG, pptr->name, total_usage);

		}
			break;
	}

	send_prefix_to_client(meptr, pptr,
		IRCD_REPLY(RPL_ENDOFSTATS, pptr->name), *thing);

	return 3;
}

#if 0
int m_help(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	if (!IsServer(lptr) && !IsReg(pptr))
	{
		send_prefix_to_client(meptr, pptr, IRCD_REPLY(ERR_NOTREGISTERED, NULL));
		return 3;
	}
	return 3;
}
#endif

int m_error(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	if (args && *args &&
			(IsServer(lptr) || (lptr->c_flags & CLIENT_FLAGS_SCONNECT)))
	{
		if (*args == ':')
			args++;
		send_to_opers("ERROR from %s: %s", lptr->name, args);
		return 3;
	}
	/* ignore ERROR */
	return 3;
}

int _do_connect(IRCD_CLIENT *pptr, SERVLINK *sptr, int portnum)
{
	int				port = 6667;
	IRCD_CLIENT		*acptr;
	int				afd;
	int				ret;
	char			cnamebuf[CLIENTNAMESIZE];
	ircd_uint32_t	ipaddr = -1;
	struct sockaddr_in	loc_sin;
	struct sockaddr_in	rem_sin;
	int				sin_size;

	if (portnum > 0)
		port = portnum;
	else if (sptr->port > 0)
		port = sptr->port;

	if (pptr)
	{
		send_prefix_to_client(meptr, pptr,
			"NOTICE %s :*** Connecting to %s[%s].",
			pptr->name, sptr->servername, sptr->hostname);
	}
	else
	{
		send_to_opers("Trying to connect to %s[%s].",
			sptr->servername, sptr->hostname);
	}

	if (sptr->inaddr.s_addr != -1)
		ipaddr = sptr->inaddr.s_addr;
	else
	{
		/*
		** TODO  -- do DNS lookup and continue to try to connect when
		**  have the answer 
		*/
		if (pptr)
		{
			send_prefix_to_client(meptr, pptr,
				"NOTICE %s :*** Couldn't connect to %s: Unknown host -- try /REHASH to try to resolve again",
				pptr->name, sptr->servername);
		}
		else
		{
			send_wallops_to_flag(CLIENT_NFLAGS_SWALLOPS, NULL, meptr,
				"Couldn't connect to %s: Unknown host.", sptr->hostname);
		}
		sptr->tryconnecttime = 0;
        return -1;
	}
    afd = mysocket_connectip(ipaddr, port,
			sptr->bindipaddr == -1 ? INADDR_ANY : sptr->bindipaddr,
			MYSOCKET_FLAGS_REUSEADDR|MYSOCKET_FLAGS_NONBLOCKING);
	if (afd < 0)   
	{
		if (pptr)
		{
			send_prefix_to_client(meptr, pptr,
				"NOTICE %s :*** Couldn't connect to %s: %i",
				pptr->name, sptr->servername, afd);
		}
		else
		{
			send_wallops_to_flag(CLIENT_NFLAGS_SWALLOPS, NULL, meptr,
				"Couldn't connect to %s: %s.", sptr->hostname,
				support_strerror(-afd));
		}
		sptr->tryconnecttime = 0;
		return -1;
	}

	acptr = (IRCD_CLIENT *)MyMalloc(sizeof(IRCD_CLIENT));
	acptr->c_connptr = (IRCD_CONN *)MyMalloc(sizeof(IRCD_CONN));
	acptr->c_connptr->conn_type = IRCD_CONN_TYPE_CLIENT;
	acptr->c_connptr->conn_ptr = (void *)acptr;

	support_strncpy(acptr->name, sptr->servername, sizeof(acptr->name));

	acptr->c_lasttime = acptr->c_firsttime = Now;

	acptr->c_connectby = MyMalloc(CLIENTNAMESIZE);
	sprintf(acptr->c_connectby, "AutoConn!*@%s", meptr->name);

	sin_size = sizeof(loc_sin);
	ret = getsockname(afd, (struct sockaddr *)(&loc_sin), &sin_size);
	if (ret >= 0)
	{
		acptr->c_loc_ipaddr = ntohl(loc_sin.sin_addr.s_addr);
		acptr->c_loc_port = ntohs(loc_sin.sin_port);
	}
	acptr->c_rem_ipaddr = ipaddr;
	acptr->c_rem_port = port;
	rem_sin.sin_addr.s_addr = htonl(ipaddr);
	strcpy(acptr->c_ipstring, inet_ntoa(rem_sin.sin_addr));
	acptr->c_type = CLIENT_TYPE_UNKNOWN;
	acptr->c_flags |= CLIENT_FLAGS_DOINGCONNECT|CLIENT_FLAGS_SCONNECT;
	acptr->c_from = acptr;
	ret = queue_init(&(acptr->c_queue_in), QUEUE_SIZE, QUEUEINIT_FLAGS);
	if (ret)
	{
		close(afd);
		MyFree(acptr->c_connectby);
		MyFree(acptr->c_connptr);
		MyFree(acptr);
		if (pptr)
		{
			send_prefix_to_client(meptr, pptr,
				"NOTICE %s :*** Couldn't connect to %s: queue_init(): %i",
				pptr->name, sptr->servername, ret);
		}
		else
		{
			send_wallops_to_flag(CLIENT_NFLAGS_SWALLOPS, NULL, meptr,
				"Couldn't connect to %s: queue_init(): %s", sptr->servername,
				support_strerror(-ret));
		}
		sptr->tryconnecttime = 0;
		return -1;
	}
	ret = queue_init(&(acptr->c_queue_out), QUEUE_SIZE, QUEUEINIT_FLAGS);
	if (ret)
	{
		queue_delete(&(acptr->c_queue_in));
		MyFree(acptr->c_connectby);
		MyFree(acptr->c_connptr);
		MyFree(acptr);
		close(afd);
		if (pptr)
		{
			send_prefix_to_client(meptr, pptr,
				"NOTICE %s :*** Couldn't connect to %s: queue_init(): %i",
				pptr->name, sptr->servername, ret);
		}
		else
		{
			send_wallops_to_flag(CLIENT_NFLAGS_SWALLOPS, NULL, meptr,
				"Couldn't connect to %s: queue_init(): %s", sptr->servername,
				support_strerror(-ret));
		}
		sptr->tryconnecttime = 0;
		return -1;
	}

	if (ircd_open_fd(afd, FDLIST_FLAGS_READ|FDLIST_FLAGS_WRITE, acptr->c_connptr, NULL) < 0)
	{
		queue_delete(&(acptr->c_queue_out));
		queue_delete(&(acptr->c_queue_in));
   		close(afd);
		MyFree(acptr->c_connectby);
		MyFree(acptr->c_connptr);
		MyFree(acptr);
		sptr->tryconnecttime = 0;
		return -1;
	}
	acptr->c_flags |= CLIENT_FLAGS_LOCAL;
	add_client_to_lolist(&Locals, acptr);

	acptr->c_hostmask = sptr->hostmask;

	acptr->c_maxsendq = 1000000; /* this will get reset in m_server */
	acptr->c_pingfreq = 300;

	if (sptr->cpasswd && *sptr->cpasswd)
		send_to_client(acptr, "PASS %s :TS", sptr->cpasswd);
	send_capabilities(acptr, 0);
	send_to_client(acptr, "SERVER %s 1 :%s",
		conf_myname_for_link(meptr->name, acptr->c_hostmask, cnamebuf),
		meptr->ircname);

	sptr->tryconnecttime = Now;

	return 0;
}

/*
** m_connect
**  parv[0] = sender prefix
**  parv[1] = servername
**  parv[2] = port number
**  parv[3] = remote server
*/
int m_connect(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	char			*server = NULL;
	char			*portnum = NULL;
	char			*remserver;
	int				port = -1;
	IRCD_CLIENT		*acptr;
	SERVLINK		*sptr;
	char			cnamebuf[CLIENTNAMESIZE];
	int				already = 0;
	char			argssave[512];

	if (!IsServer(lptr) && !IsAnOper(pptr))
	{
		send_prefix_to_client(meptr, pptr,
			IRCD_REPLY(ERR_NOPRIVILEGES, pptr->name));  
		return 3;
	}

	if (MyClient(pptr) && !(pptr->c_oline_flags & OLINE_FLAGS_CANGLOBALROUTE) &&
			args && *args)
	{
		char *argptr = argssave;

		support_strncpy(argptr, args, sizeof(argssave));

		server = ircd_nextarg(&argptr, 0);
		portnum = ircd_nextarg(&argptr, 0);
		remserver = ircd_nextarg(&argptr, 0);
		if (remserver && *remserver)
		{
			send_prefix_to_client(meptr, pptr,
				"NOTICE %s :You are not allowed to GLOBAL ROUTE", pptr->name);
			return 3;
		}
		already = 1;
	}

	if (_hunt_server(lptr, pptr, ":%s CONNECT %s %s :%s", 3, prefix,
				args) != HUNTED_ISME)
		return 3;

	if (MyClient(pptr) && !(pptr->c_oline_flags & OLINE_FLAGS_CANLOCALROUTE))
	{
		send_prefix_to_client(meptr, pptr,
			"NOTICE %s :You are not allowed to LOCAL ROUTE", pptr->name);
		return 3;
	}

	if (!already)
	{
		server = ircd_nextarg(&args, 0);
		portnum = ircd_nextarg(&args, 0);
		remserver = ircd_nextarg(&args, 0);
	}

	if (!server || !*server)
	{
		send_prefix_to_client(meptr, pptr, IRCD_REPLY(ERR_NEEDMOREPARAMS,
					pptr->name), "CONNECT");
		return 3;
	}

	for(sptr=_ircd_conf.servers;sptr;sptr=sptr->next)
		if (!match(server, sptr->hostname))
			break;
	if (!sptr)
	{
		for(sptr=_ircd_conf.servers;sptr;sptr=sptr->next)
			if (!match(server, sptr->servername))
				break;
	}

	if (!sptr)
	{
		send_prefix_to_client(meptr, pptr,
			"NOTICE %s :Connect: Host %s not listed in config file",
			pptr->name, server);
		return 3;
	}

	if (sptr)
	{
		if (Now < (sptr->tryconnecttime + 60))
		{
			send_prefix_to_client(meptr, pptr,
				"NOTICE %s :Connect: Already trying to connect to %s",
				pptr->name, server);
			return 3;
		}
	}

	if (!*sptr->cpasswd || !*sptr->npasswd)
	{
		send_prefix_to_client(meptr, pptr,
			"NOTICE %s :Connect: Missing cpasswd or npasswd from conf file for %s",
				pptr->name, server);
		return 3;
	}

	acptr = hash_find_client_incl_hm(sptr->servername);
	if (acptr)
	{
		send_prefix_to_client(meptr, pptr,
			"NOTICE %s :Connect: Server %s already exists from %s.",
			pptr->name, sptr->servername, acptr->c_from->name);
		return 3;
	}

	if (portnum && *portnum)
	{
		int p = atoi(portnum);

		if (p <= 0)
		{
			if (IsClient(pptr))
				send_prefix_to_client(meptr, pptr,
					"NOTICE %s :Connect: Invalid port.", pptr->name);
			return 3;
		}
		port = p;
	}

	if (IsServer(lptr))
	{
		send_wallops_to_flag(CLIENT_NFLAGS_SWALLOPS, NULL, meptr,
			"Remote CONNECT %s %i from %s",
			server, port, ircd_clientname(pptr, 0, cnamebuf));
		send_to_servers(lptr, ":%s WALLOPS :Remote CONNECT %s %i from %s",
			meptr->name, server, port, ircd_clientname(pptr, 0, cnamebuf));
	}

	(void)_do_connect(pptr, sptr, port);

	return 3;
}

#if 0
int m_ping(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	char			*origin = ircd_nextarg(&args, 0);
	char			*destination = ircd_nextarg(&args, 0);
	IRCD_CLIENT		*acptr;

	if (!origin || !*origin)
	{
		send_prefix_to_client(meptr, pptr,
					IRCD_REPLY(ERR_NOORIGIN, pptr->name));
		return 3;
	}
	acptr = hash_find_client_incl_hm(origin);
	if (acptr && acptr != pptr)
		origin = lptr->name;
	if (destination && mycmp(destination, meptr->name))
	{
		acptr = hash_find_client_incl_hm(destination);
		if (!acptr || !IsServer(acptr))
		{
			send_prefix_to_client(meptr, pptr,
				IRCD_REPLY(ERR_NOSUCHSERVER, pptr->name), destination);
		}
		else
		{
			if (IsServer(pptr))
				send_to_client(acptr, ":%s PING %s :%s",
					prefix, origin, destination);
			else
				send_prefix_to_client(pptr, acptr, "PING %s :%s",
					origin, destination);
		}
	}
	else
		send_prefix_to_client(meptr, pptr, "PONG %s :%s", 
			(destination) ? destination : meptr->name, origin);
	return 3;
}

int m_pong(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	char			*origin = ircd_nextarg(&args, 0);
	char			*destination = ircd_nextarg(&args, 0);
	IRCD_CLIENT		*acptr;

	if (!origin || !*origin)
	{
		send_prefix_to_client(meptr, pptr,
					IRCD_REPLY(ERR_NOORIGIN, pptr->name));
		return 3;
	}

	/* ping reset in ircd_parse() */

	if (!IsServer(lptr) && !IsReg(lptr))
		return 3;

	if (IsServer(pptr) && CliSentEOB(pptr) && !CliGotEOB(pptr))
	{
		if (pptr == lptr)
		{
			send_to_opers(
				"End-of-Burst acknowledged from %s",
				lptr->name);
		}
		Globalinfo->g_serversbursting--;
		CliSetGotEOB(pptr);
	}

	if (destination && mycmp(destination, meptr->name))
	{
		acptr = hash_find_client_incl_hm(destination);
		if (acptr)
		{
			if (IsClient(pptr))
				send_prefix_to_client(pptr, acptr, "PONG %s %s",
					origin, destination);
			else
				send_to_client(acptr, ":%s PONG %s %s",
					prefix, origin, destination);
		}
		else
		{
			send_prefix_to_client(meptr, pptr,
				IRCD_REPLY(ERR_NOSUCHSERVER, pptr->name),
				destination);
		}
	}
	return 3;
}

int m_pass(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	char	*password = ircd_nextarg(&args, 0);

	if (!password || !*password)
	{
		if (IsClient(pptr))
			send_prefix_to_client(meptr, pptr, IRCD_REPLY(ERR_NEEDMOREPARAMS,
				*pptr->name ? pptr->name : "*"), "PASS");
		return 3;
	}
	if (!IsLocal(pptr) || !IsUnknown(lptr))
	{
		if (IsClient(pptr))
			send_prefix_to_client(meptr, pptr, IRCD_REPLY(ERR_ALREADYREGISTRED,
				pptr->name));
		return 3;
	}
	support_strncpy(pptr->c_passwd, password, sizeof(pptr->c_passwd));
	if (args && *args)
	{
		int	l = strlen(args);

		if (l < 2)
			return 3;
		if (!strcmp(args+l-2, "TS"))
			pptr->c_flags |= CLIENT_FLAGS_DOESTS;
	}
	return 3;
}
#endif
int m_time(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	char	datebuf[128];

	if (!IsServer(lptr) && !IsReg(pptr))
	{
		send_prefix_to_client(meptr, pptr, IRCD_REPLY(ERR_NOTREGISTERED, NULL));
		return 3;
	}

	if (_hunt_server(lptr, pptr, ":%s TIME :%s", 1, prefix, args) == HUNTED_ISME)
		send_prefix_to_client(meptr, pptr, IRCD_REPLY(RPL_TIME, pptr->name),
			meptr->name, datestr(0, datebuf));
	return 3;
}

int m_admin(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	if (!IsServer(lptr) && !IsReg(pptr))
	{
		send_prefix_to_client(meptr, pptr, IRCD_REPLY(ERR_NOTREGISTERED, NULL));
		return 3;
	}

	if (_hunt_server(lptr, pptr, ":%s ADMIN :%s", 1, prefix, args) != HUNTED_ISME)
		return 3;

	if (_ircd_conf.admin && *_ircd_conf.admin)
	{
		char	**lines;
		int		i;
		int		num;

		send_prefix_to_client(meptr, pptr,
				IRCD_REPLY(RPL_ADMINME, pptr->name), meptr->name);
		for(lines=_ircd_conf.admin,i=0;*lines;i++,lines++)
		{
			if (!i)
				num = RPL_ADMINLOC1;
			else if (i == 1)
				num = RPL_ADMINLOC2;
			else
				num = RPL_ADMINEMAIL;
			send_prefix_to_client(meptr, pptr,
					IRCD_REPLY(num, pptr->name), *lines);
		}
	}
	else
		send_prefix_to_client(meptr, pptr,
				IRCD_REPLY(ERR_NOADMININFO, pptr->name), meptr->name);

	return 3;
}

int m_rehash(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
#ifdef HAVE_DLOPEN
	extern int DoReload;
#endif

	if (IsServer(lptr))
		return 3;

	if (!IsReg(pptr))
	{
		send_prefix_to_client(meptr, pptr, IRCD_REPLY(ERR_NOTREGISTERED, NULL));
		return 3;
	}

	if (!IsAnOper(pptr))
	{
		send_prefix_to_client(meptr, pptr,
			IRCD_REPLY(ERR_NOPRIVILEGES, pptr->name));
		return 3;
	}

	if (!(pptr->c_oline_flags & OLINE_FLAGS_CANREHASH))
	{
		send_prefix_to_client(meptr, pptr,
			"NOTICE %s :You are not allowed to REHASH", pptr->name);
		return 3;
	}

	if (!strcasecmp(args, "counter"))
	{
		Globalinfo->m_totclients = 0;
		Globalinfo->m_totclientstime = Now;
		send_prefix_to_client(meptr, pptr, "NOTICE %s :Counter has been reset.",
				pptr->name);
		return 3;
	}
	else if (!strcasecmp(args, "motd"))
	{
		char	*motd_file = vars_value_get_bynum(IRCD_VAR_MOTD_FILE);

		if (motd_file)
		{
			int ret;

			motd_unload(&Motd);
			ret = motd_load(motd_file, &Motd);
			if (ret < 0)
				send_prefix_to_client(meptr, pptr,
					"NOTICE %s :Couldn't load %s: %s", pptr->name,
					motd_file, support_strerror(-ret));
			else
				send_prefix_to_client(meptr, pptr,
					"NOTICE %s :Motd has been reloaded.", pptr->name);
		}
		else
		{
			send_prefix_to_client(meptr, pptr, "NOTICE %s :No MOTD_FILE specified in /set",
				pptr->name);
		}
		return 3;
	}
#ifdef HAVE_DLOPEN
	else if (!strcasecmp(args, "ircdso") || !strcasecmp(args, "reload"))
	{
		if(!(pptr->c_oline_flags & OLINE_FLAGS_CANRELOAD))
		{
			send_prefix_to_client(meptr, pptr, "NOTICE %s :You are not allowed to reload the ircd.so!", pptr->name);
			return 3;
		}

		DoReload = 1;

		send_prefix_to_client(meptr, pptr, "NOTICE %s :A ircd.so reload has been queued.", pptr->name);
#ifdef SYSLOG_RELOADS
		syslog(LOG_NOTICE, "%s!%s@%s(%s) has queued a reload of the ircd.so", pptr->name, pptr->username, pptr->hostname, pptr->c_oline_name);
#endif
		send_to_opers("%s(%s) is reloading the ircd.so while whistling innocently..", pptr->name, pptr->c_oline_name);

		return 3;
	}
#endif
	send_prefix_to_client(meptr, pptr, "NOTICE %s :Rehash has been queued.",
				pptr->name);
#ifdef SYSLOG_RELOADS
	syslog(LOG_NOTICE, "%s!%s@%s(%s) has queued a rehash of the ircd.conf", pptr->name, pptr->username, pptr->hostname, pptr->c_oline_name);
#endif

	if (!RehashWho)
	{
		RehashWho = MyMalloc(CLIENTNAMESIZE);
		ircd_clientname(pptr, 0, RehashWho);
	}
	DoRehash = 1;

	return 3;
}

#ifdef HAVE_DLOPEN
int m_reload(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	extern int DoReload;

	if(!IsReg(pptr))
	{
		 send_prefix_to_client(meptr, pptr, IRCD_REPLY(ERR_NOTREGISTERED, NULL));
		 return 3;
	}

	if(IsServer(pptr))
		return 3;
	
	if(!IsAnOper(pptr))
	{
		send_prefix_to_client(meptr, pptr, IRCD_REPLY(ERR_NOPRIVILEGES, pptr->name));
		return 3;
	}
	
	if(!(pptr->c_oline_flags & OLINE_FLAGS_CANRELOAD))
	{
		send_prefix_to_client(meptr, pptr, "NOTICE %s :You are not allowed to reload the ircd.so!", pptr->name);
		return 3;
	}
	
	DoReload = 1;
	
	send_prefix_to_client(meptr, pptr, "NOTICE %s :A ircd.so reload has been queued.", pptr->name);

#ifdef SYSLOG_RELOADS
	 syslog(LOG_NOTICE, "%s!%s@%s(%s) has queued a reload of the ircd.so", pptr->name, pptr->username, pptr->hostname, pptr->c_oline_name);
#endif
	 send_to_opers("%s(%s) is reloading the ircd.so while whistling innocently..", pptr->name, pptr->c_oline_name);

	 return 3;
}
#endif

int m_restart(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	return 3;
}

int m_close(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	return 3;
}

int m_svinfo(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	char	*ts_cur = ircd_nextarg(&args, 0);
	char	*ts_min = ircd_nextarg(&args, 0);
	char	*standalone = ircd_nextarg(&args, 0);
	char	*thetime = ircd_nextarg(&args, 0);
	char	cnamebuf[CLIENTNAMESIZE];

	if (!IsServer(pptr) || !IsLocal(pptr) || !thetime || !*thetime)
		return 3;

	standalone = NULL; /* standalone is not used, and this stops gcc warning */

	/* pptr == lptr */

	if (!DoesTS(lptr))
	{
		send_to_opers("Link %s dropped, non-TS server",
				ircd_clientname(lptr, 1, cnamebuf));
		client_del(meptr, lptr, "non-TS server");
		return -1;
	}

	if (TS_CURRENT < atoi(ts_min) || atoi(ts_cur) < TS_MIN)
	{
		send_to_opers("Link %s dropped, wrong TS protocol version (%s,%s)",
				ircd_clientname(lptr, 1, cnamebuf), ts_cur, ts_min);
		/* lptr == lptr */
		client_del(meptr, lptr, "wrong TS protocol");
		return -1;
	}
	return 3;
}

#if 0 /* moved to channel.c */
/*
** m_sjoin
** parv[0] - sender
** parv[1] - TS
** parv[2] - channel
** parv[3] - modes + n arguments (key and/or limit)
** parv[4+n] - flags+nick list (all in one parameter)
*/
int m_sjoin(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	char	*ts = ircd_nextarg(&args, 0);
	char	*channel = ircd_nextarg(&args, 0);
	char	*modes = ircd_nextarg(&args, 0);
	char	*modeargs = args;
	char	*newkey = NULL;
	int		newlimit = 0;
	char	*tempptr;
	char	*ptr;
	int		newts;
	int		oldts;
	int		isnew = 0;
	int		doesop = 0;
	int		haveops = 0;
	int		keepourmodes = 1;
	int		keepnewmodes = 1;
	int		newmodes;
	int		oldmodes;
	int		tstosend;
	char	plusminus;
	char	modebuf[512];
	char	modeargbuf[512];
	char	*modeptr = modebuf;
	char	*modeargptr = modeargbuf;
	char	largebuf[1024];
	int		people;
	IRCD_CLIENT	*acptr;
	IRCD_CHANNEL	*chptr;
	IRCD_CLIENTLIST	*clptr;
	char	*name;
	int		flags;
	char	*sptr;
	int		pargs;
	int		*i;

	if (!IsServer(pptr))
	{
		if (IsLocal(pptr))
			;
		return 3;
	}

	if (!modeargs || !*modeargs)
		return 3;

	if (*channel == '&')
		return 3;

	newts = atoi(ts);
	chptr = hash_find_channel(channel);

	newmodes = 0;

	for(ptr=modes;*ptr;ptr++)
	{
		switch(*ptr)
		{
			case 'i':
				newmodes |= CHANNEL_MODES_INVITEONLY;
				break;
			case 'm':
				newmodes |= CHANNEL_MODES_MODERATED;
				break;
			case 'n':
				newmodes |= CHANNEL_MODES_NOPRIVMSGS;
				break;
			case 'p':
				newmodes |= CHANNEL_MODES_PRIVATE;
				break;
			case 's':
				newmodes |= CHANNEL_MODES_SECRET;
				break;
			case 't':
				newmodes |= CHANNEL_MODES_TOPICLIMIT;
				break;
			case 'k':
				newkey = ircd_next_subarg_space(&modeargs);
				if (newkey && !*newkey)
					newkey = NULL;
				break;
			case 'l':
				tempptr = ircd_next_subarg_space(&modeargs);
				if (tempptr)
					newlimit = atoi(tempptr);
				break;
		}
	}
			
	if (!chptr)
	{
		isnew = 1;
		chptr = (IRCD_CHANNEL *)MyMalloc(sizeof(IRCD_CHANNEL)+strlen(channel));
		strcpy(chptr->name, channel);
		hash_add_channel(chptr);
		if (++Globalinfo->channels > Globalinfo->maxchannels)
		{
			Globalinfo->maxchannels = Globalinfo->channels;
			Globalinfo->maxchannelstime = Now;
		}
	}
	oldts = chptr->creation;

	if (modeargs && (*modeargs == ':'))
		modeargs++;

	if (modeargs && !isnew && (newts > 0) && (oldts > 0) && (newts != oldts))
	{
		char	*start = modeargs;
		char	save;

		for(ptr=start;;ptr++)
		{
			if (*ptr && *ptr != ' ')
				continue;
			save = *ptr;
			*ptr = '\0';
			if ((*start == '@') || (*(start+1) == '@'))
			{
				if ((*++start == '@') || (*start == '+'))
					start++;
				if (((acptr = hash_find_chasing(start)) != NULL) &&
						(acptr->c_from == lptr))
				{
					*ptr = save;
					doesop = 1;
					break;
				}
			
			}
			start = ptr+1;
			if (save == '\0')
				break;
			else
				*ptr = save;
		}
	}

	for(clptr=chptr->members;clptr;clptr=clptr->next)
	{
		if (clptr->modes & CHANNEL_MODES_CHANOP)
		{
			haveops = 1;
			break;
		}
	}

	oldmodes = chptr->modes;

	if (isnew)
		chptr->creation = tstosend = newts;
	else if (!newts || !oldts)
		chptr->creation = tstosend = 0;
	else if (newts == oldts)
		tstosend = oldts;
	else if (newts < oldts)
	{
#ifdef TS5
		keepourmodes = 0;
		chptr->creation = tstosend = newts;
#else
		if (doesop)
		{
			keepourmodes = 0;
			chptr->creation = tstosend = newts;
		}
		else if (haveops)	/* !doesop and we have ops */
		{
			tstosend = oldts;
		}
		else /* !doesop and we don't have ops */
		{
			chptr->creation = tstosend = newts;
		}
#endif
	}
	else
	{
#ifdef TS5
		keepnewmodes = 0;
		tstosend = oldts;
#else
		if (haveops)
		{
			keepnewmodes = 0;
			tstosend = oldts;
		}
		else if (doesop) /* !haveops && doesop */
		{
			chptr->creation = tstosend = newts;
			send_to_opers("Hacked ops on opless channel: %s from %s",
					chptr->name, pptr->name);
		}
		else /* !haveops && !doesop */
			tstosend = oldts;
#endif
	}

	if (!keepnewmodes)
	{
		newmodes = oldmodes;
		newkey = chptr->key;
		newlimit = chptr->limit;
	}
	else if (keepourmodes)
	{
		newmodes |= oldmodes;
		if (chptr->limit > newlimit)
			newlimit = chptr->limit;
		if (strcmp(newkey ? newkey : "", chptr->key ? chptr->key : "") < 0)
			newkey = chptr->key;
	}

	plusminus = '\0';

	if (newmodes != oldmodes)
	{
		for(i=_channel_modes;*i;i+=2)
		{
			if ((*i & newmodes) && !(*i & oldmodes))
			{
				if (plusminus != '+')
				{
					plusminus = '+';
					*modeptr++ = plusminus;
				}
				*modeptr++ = *(i+1);
			}
		}

		for(i=_channel_modes;*i;i+=2)
		{
			if ((*i & oldmodes) && !(*i & newmodes))
			{
				if (plusminus != '-')
				{
					plusminus = '-';
					*modeptr++ = plusminus;
				}
				*modeptr++ = *(i+1);
			}
		}
	}

	if (chptr->limit && !newlimit)
	{
		if (plusminus != '-')
		{
			plusminus = '-';
			*modeptr++ = plusminus;
		}
		*modeptr++ = 'l';
	}

	if (chptr->key && !newkey)
	{
		if (plusminus != '-')
		{
			plusminus = '-';
			*modeptr++ = plusminus;
		}
		*modeptr++ = 'k';
		if (modeargptr != modeargbuf)
			*modeargptr++ = ' ';
		for(sptr=chptr->key;*sptr;)
			*modeargptr++ = *sptr++;
	}

	if (newlimit && (newlimit != chptr->limit))
	{
		char buf[20];

		if (plusminus != '+')
		{
			plusminus = '+';
			*modeptr++ = plusminus;
		}
		*modeptr++ = 'l';
		sprintf(buf, "%-15d", newlimit);
		if (modeargptr != modeargbuf)
			*modeargptr++ = ' ';
		for(sptr=buf;*sptr && (*sptr != ' ');)
			*modeargptr++ = *sptr++;
	}

	if (newkey && (!chptr->key || mycmp(chptr->key, newkey)))
	{
		if (plusminus != '+')
		{
			plusminus = '+';
			*modeptr++ = plusminus;
		}
		*modeptr++ = 'k';
		if (modeargptr != modeargbuf)
			*modeargptr++ = ' ';
		for(sptr=newkey;*sptr;)
			*modeargptr++ = *sptr++;
	}

	chptr->modes = newmodes;

	if (newkey != chptr->key)
	{
		if (chptr->key)
			MyFree(chptr->key);
		chptr->key = !newkey ? newkey : MyStrdup(newkey);
	}
	if (newlimit != chptr->limit)
		chptr->limit = newlimit;

	if (!keepourmodes)
	{
		char	meplusminus = '\0';
		int		mpargs = 0;
		char	memodebuf[512];
		char	memodeargbuf[512];
		char	*memodeptr = memodebuf;
		char	*memodeargptr = memodeargbuf;

		for(clptr=chptr->members;clptr;clptr=clptr->next)
		{
			if (clptr->modes & CHANNEL_MODES_CHANOP)
			{
				if (meplusminus != '-')
				{
					meplusminus = '-';
					*memodeptr++ = meplusminus;
				}
				*memodeptr++ = 'o';
				if (memodeargptr != memodeargbuf)
					*memodeargptr++ = ' ';
				for(sptr=clptr->cptr->name;*sptr;)
					*memodeargptr++ = *sptr++;
				if (++mpargs == MAXMODEPARAMS)
				{
					*memodeptr = '\0';
					*memodeargptr = '\0';
					send_to_channel_butone(NULL,
						CHANNEL_SEND_CLIENTS|CHANNEL_SEND_LOCALONLY,
						chptr, meptr, "MODE %s %s %s", chptr->name,
						memodebuf, memodeargbuf);
					memodeptr = memodebuf;
					memodeargptr = memodeargbuf;
					meplusminus = '\0';
					mpargs = 0;
				}
				clptr->modes &= ~CHANNEL_MODES_CHANOP;
			}
			if (clptr->modes & CHANNEL_MODES_VOICE)
			{
				if (meplusminus != '-')
				{
					meplusminus = '-';
					*memodeptr++ = meplusminus;
				}
				*memodeptr++ = 'v';
				if (memodeargptr != memodeargbuf)
					*memodeargptr++ = ' ';
				for(sptr=clptr->cptr->name;*sptr;)
					*memodeargptr++ = *sptr++;
				if (++mpargs == MAXMODEPARAMS)
				{
					*memodeptr = '\0';
					*memodeargptr = '\0';
					send_to_channel_butone(NULL,
						CHANNEL_SEND_CLIENTS|CHANNEL_SEND_LOCALONLY,
						chptr, meptr, "MODE %s %s %s", chptr->name,
						memodebuf, memodeargbuf);
					memodeptr = memodebuf;
					memodeargptr = memodeargbuf;
					meplusminus = '\0';
					mpargs = 0;
				}
				clptr->modes &= ~CHANNEL_MODES_VOICE;
			}
		} /* for() */
		if (memodeptr != memodebuf)
		{
			*memodeptr = '\0';
			*memodeargptr = '\0';
			send_to_channel_butone(NULL,
				CHANNEL_SEND_CLIENTS|CHANNEL_SEND_LOCALONLY,
				chptr, meptr, "MODE %s %s %s", chptr->name,
				memodebuf, memodeargbuf);
		}
	} /* (!keepourmodes) */

	if (modeptr != modebuf)
	{
		*modeptr = '\0';
		*modeargptr = '\0';
		if (IsClient(pptr))
		{
			send_to_channel_butone(NULL,
				CHANNEL_SEND_CLIENTS|CHANNEL_SEND_LOCALONLY,
				chptr, pptr, "MODE %s %s %s", chptr->name,
				modebuf, modeargbuf);
		}
		else
		{
			send_to_channel_butone2(NULL,
				CHANNEL_SEND_CLIENTS|CHANNEL_SEND_LOCALONLY,
				chptr, prefix, "MODE %s %s %s", chptr->name,
				modebuf, modeargbuf);
		}
		modeptr = modebuf;
		modeargptr = modeargbuf;
	}

	if ((*modes != '0') && keepnewmodes)
		_build_channel_modes(chptr, pptr, modebuf, modeargbuf);
	else
	{
		modebuf[0] = '0';
		modebuf[1] = '\0';
		modeargbuf[0] = '\0';
	}

	tempptr = largebuf;
	tempptr += sprintf(tempptr, ":%s SJOIN %d %s %s %s :",
				prefix, tstosend, chptr->name,
				modebuf, modeargbuf);

	*modeptr++ = '+';

	people = 0;
	pargs = 0;


	for(name = ircd_next_subarg_space(&modeargs);name;
					name = ircd_next_subarg_space(&modeargs))
	{
		char *savename = name;

		flags = 0;
		if (*name == '@' || *(name+1) == '@')
			flags |= CHANNEL_MODES_CHANOP;
		if (*name == '+' || *(name+1) == '+')
			flags |= CHANNEL_MODES_VOICE;

		if (flags && ((*++name == '@') || (*name == '+')))
			name++;

		if (!keepnewmodes)
		{
			if (flags & CHANNEL_MODES_CHANOP)
				flags = CHANNEL_MODES_DEOPPED;
			else
				flags = 0;
		}

		if (!(acptr = hash_find_chasing(name)) || (acptr->c_from != lptr))
			continue;
		people++;

		if (!IsMember(chptr, acptr))
		{
			_channel_add_user(chptr, acptr, flags);
			send_to_channel_butone(NULL,
				CHANNEL_SEND_CLIENTS|CHANNEL_SEND_LOCALONLY,
				chptr, acptr, "JOIN :%s", chptr->name);
		}
		if (keepnewmodes)
			strcpy(tempptr, savename);
		else
			strcpy(tempptr, name);
		tempptr += strlen(tempptr);
		*tempptr++ = ' ';
		if (flags & CHANNEL_MODES_CHANOP)
		{
			*modeptr++ = 'o';
			if (modeargptr != modeargbuf)
				*modeargptr++ = ' ';
			for(sptr=name;*sptr;)
				*modeargptr++ = *sptr++;
			if (++pargs == MAXMODEPARAMS)
			{
				*modeptr = '\0';
				*modeargptr = '\0';
				if (IsClient(pptr))
					send_to_channel_butone(NULL,
						CHANNEL_SEND_CLIENTS|CHANNEL_SEND_LOCALONLY,
						chptr, pptr, "MODE %s %s %s", chptr->name,
						modebuf, modeargbuf);
				else
					send_to_channel_butone2(NULL,
						CHANNEL_SEND_CLIENTS|CHANNEL_SEND_LOCALONLY,
						chptr, prefix, "MODE %s %s %s", chptr->name,
						modebuf, modeargbuf);
				pargs = 0;
				modeptr = modebuf;
				modeargptr = modeargbuf;
				*modeptr++ = '+';
			}
		}
		if (flags & CHANNEL_MODES_VOICE)
		{
			*modeptr++ = 'v';
			if (modeargptr != modeargbuf)
				*modeargptr++ = ' ';
			for(sptr=name;*sptr;)
				*modeargptr++ = *sptr++;
			if (++pargs == MAXMODEPARAMS)
			{
				*modeptr = '\0';
				*modeargptr = '\0';
				if (IsClient(pptr))
					send_to_channel_butone(NULL,
						CHANNEL_SEND_CLIENTS|CHANNEL_SEND_LOCALONLY,
						chptr, pptr, "MODE %s %s %s", chptr->name,
						modebuf, modeargbuf);
				else
					send_to_channel_butone2(NULL,
						CHANNEL_SEND_CLIENTS|CHANNEL_SEND_LOCALONLY,
						chptr, prefix, "MODE %s %s %s", chptr->name,
						modebuf, modeargbuf);
				pargs = 0;
				modeptr = modebuf;
				modeargptr = modeargbuf;
				*modeptr++ = '+';
			}
		}
	}

	if (modeptr != (modebuf+1))
	{
		*modeptr = '\0';
		*modeargptr = '\0';
		if (IsClient(pptr))
			send_to_channel_butone(NULL,
				CHANNEL_SEND_CLIENTS|CHANNEL_SEND_LOCALONLY,
				chptr, pptr, "MODE %s %s %s", chptr->name, modebuf, modeargbuf);
		else
			send_to_channel_butone2(NULL,
				CHANNEL_SEND_CLIENTS|CHANNEL_SEND_LOCALONLY,
				chptr, prefix, "MODE %s %s %s", chptr->name, modebuf, modeargbuf);
	}

	if (people)
	{
		if (*(tempptr-1) == ' ')
			tempptr--;
		*tempptr = '\0';
		send_to_servers(lptr, "%s", largebuf);
	}

	return 3;
}
#endif

int m_die(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	if (IsServer(lptr))
		return 3;

	if (!IsReg(pptr))
	{
		send_prefix_to_client(meptr, pptr, IRCD_REPLY(ERR_NOTREGISTERED, NULL));
		return 3;
	}

	if (!IsAnOper(lptr))
	{
		send_prefix_to_client(meptr, pptr,
			IRCD_REPLY(ERR_NOPRIVILEGES, pptr->name));
		return 3;
	}

	if (!(pptr->c_oline_flags & OLINE_FLAGS_CANDIE))
	{
		send_prefix_to_client(meptr, pptr,
			"NOTICE %s :You are not allowed to DIE", pptr->name);
		return 3;
	}

	syslog(LOG_NOTICE, "%s!%s@%s(%s) is using DIE", pptr->name, pptr->username, pptr->hostname, pptr->c_oline_name);
	
	exit(0);
	return 0; /* so some gccs don't complain */
}

int m_dns(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	return 3;
}

int m_capab(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	char		*capab = ircd_nextarg(&args, NEXTARG_FLAGS_LASTARG);
	char		*ptr;
	IRCD_CAPAB	*cptr;

	if (!capab || !*capab)
		return 0;
	while((ptr = ircd_next_subarg_space(&capab)) != NULL)
	{
		for(cptr=_ircd_capabs;cptr->name;cptr++)
			if (!strcmp(cptr->name, ptr))
				lptr->c_capab_flags |= cptr->value;
	}
	return 0;
}

int m_ext(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	return 3;
}
#if 0
int m_operwall(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	return m_wallops(lptr, pptr, prefix, args);
}
#endif
#ifdef KLINES
int m_kline(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	char	*mask;
	char	*user;
	char	*host = NULL;
	char	*reason;
	char	*timelimit = NULL;
	char	*ptr;
	char	tempuser[USERLEN+1];
	int		ret;
	int		expires = -1;
	int		ip_or_host;
	char	buffer[1024];
	char	*filename;
	int		fd;
	CONFHOSTIPENTRY		*entryptr;
	ircd_uint32_t	ipaddr;
	ircd_uint32_t	ipmask;
	int		failed = 1;

	if (!IsAnOper(pptr) && !IsServer(pptr))
	{
		send_prefix_to_client(meptr, pptr,
			IRCD_REPLY(ERR_NOPRIVILEGES, pptr->name));
		return 3;
	}

	if (MyClient(pptr) && !(pptr->c_oline_flags & OLINE_FLAGS_CANKLINE))
	{
		send_prefix_to_client(meptr, pptr,
			"NOTICE %s :You are not allowed to KLINE", pptr->name);
		return 3;
	}

	mask = ircd_nextarg(&args, 0);

	if (mask && isdigit(*mask))
	{
		char *ptr = mask;

		while(*mask && isdigit(*mask))
			mask++;
		if (!*mask || !*(mask+1))
		{
			timelimit = ptr;
			mask = ircd_nextarg(&args, 0);
		}
		else
			mask = ptr;
	}

	if (!mask || !*mask)
	{
		if (IsClient(pptr))
			send_prefix_to_client(meptr, pptr, IRCD_REPLY(ERR_NEEDMOREPARAMS,
				pptr->name), "KLINE");
		return 3;
	}

	user = mask;

	if (MyClient(pptr))
	{
		reason = ircd_nextarg(&args, NEXTARG_FLAGS_LASTARG);
	}
	else
	{
		host = ircd_nextarg(&args, 0);

		if (!host || !*host)
			return 3;

		reason = ircd_nextarg(&args, 0);
	}

	if (!host)
	{
		for(ptr=user;*ptr;ptr++)
			if ((*ptr == '@') || (*ptr == '*') || (*ptr == '.') || (*ptr == '/'))
				break;

		if (*ptr)
		{
			while(*ptr && (*ptr != '@'))
				ptr++;
			if (*ptr)
			{
				*ptr++ = '\0';
				host = ptr;
			}
			else
			{
				host = user;
				user = "*";
			}
			if (!host || !*host)
				host = "*";

			if (strcmp(host, "*") && (1 == cidr_ip2netmask(host, &ipaddr, &ipmask)))
				ip_or_host = 0;
			else
				ip_or_host = 1;
		}
		else
		{
			IRCD_CLIENT		*acptr = hash_find_client(mask);

			if (!acptr)
				acptr = whowas_get_history(mask, 0);

			if (!acptr)
			{
				send_prefix_to_client(meptr, pptr,
						IRCD_REPLY(ERR_NOSUCHNICK, pptr->name), mask);
				return 3;
			}

			if (!IsPerson(acptr) || !IsReg(acptr))
			{
				send_prefix_to_client(meptr, pptr,
			"NOTICE %s :Can't KLINE an unregistered connection or a server",
					pptr->name);
				return 3;
			}

			tempuser[0] = '*';
			if (*acptr->username == '~')
				strcpy(tempuser + 1, acptr->username+1);
			else
				strcpy(tempuser + 1, acptr->username);
			user = tempuser;
			host = _cluster(acptr->hostname, &ip_or_host);
		}
	}

	if (!reason || !*reason)
		reason = "No reason specified";

	if (strlen(reason) > 200)
		reason[200] = '\0';

	if (!match(user, ".....") && !match(host, "...ba.."))
	{
		send_prefix_to_client(meptr, pptr, "NOTICE %s : Can't K-Line *@*",
			pptr->name);
		return 3;
	}

#if 0	/* the ability to pass on klines has been removed since glines do that already 
	 * .. if you wish to re-add it, re-add the var to vars.h and remove the #if 0 on this 
	 * block of code.. */
	if (vars_value_get_bynum(IRCD_VAR_PASS_KLINES))
	{
		send_to_servers(IsServer(lptr) ? lptr : NULL,
				":%s KLINE %s %s :%s", prefix, user, host, reason);
	}
#endif

	if (!MyClient(pptr))
	{
		return 3;
	}

	if (timelimit)
	{
		int num = atoi(timelimit);

		if (num <= 0)
		{
			if (MyClient(pptr))
				send_prefix_to_client(meptr, pptr,
					"NOTICE %s :Invalid expire time given", pptr->name);
			return 3;
		}
		else if (num > 0)
		{
			char *ptr = timelimit;

			while(*ptr && isdigit(*ptr))
				ptr++;
			switch(*ptr)
			{
				case	'd':
				case	'D':
					expires = Now + (num * 86400);
					break;
				case	'm':
				case	'M':
					expires = Now + (num * 60);
					break;
				case	'h':
				case	'H':
					expires = Now + (num * 3600);
					break;
				case	'y':
				case	'Y':
					expires = Now + (num * 86400 * 365);
					break;
				case	'w':
				case	'W':
					expires = Now + (num * 86400 * 7);
					break;
				case	's':
				case	'S':
				default:
					expires = Now + (num * 60);
					break;
			}
		}
	}

	if (IsClient(pptr))
		sprintf(buffer, "kline by %s!%s@%s at %s",
			pptr->name, pptr->username, pptr->hostname,
			support_ctime(Now));
	else
		sprintf(buffer, "kline by %s at %s",
			pptr->name, support_ctime(Now));

	if (ip_or_host)
	{
		ret = access_match_hostname(&(_ircd_conf.deny),
				user, host, 0, &entryptr);
		if (ret >= 0)
		{
			if (IsClient(pptr))
				send_prefix_to_client(meptr, pptr,
				"NOTICE %s :KLINE \"%s@%s\" not added.  Matched by: \"%s@%s\"",
					pptr->name, user, host,
					entryptr->username ? entryptr->username : "*",
					entryptr->hostname ? entryptr->hostname : "*");
			return 3;
		}
	}
	else
	{
		ret = access_match_ipaddr(&(_ircd_conf.deny),
			user, host, ipaddr, 0, &entryptr);
		if (ret >= 0)
		{
			if (IsClient(pptr))
				send_prefix_to_client(meptr, pptr,
			"NOTICE %s :KLINE \"%s@%s\" not added.  Matched by: \"%s@%s\"",
				pptr->name, user, host,
				entryptr->username ? entryptr->username : "*",
				entryptr->ipstring ? entryptr->ipstring : "*");
			return 3;
		}
	}

	filename = Conffile; /* if your server uses klines a lot, consider making this a var for a dynamic setting on where the klines go. it was removed
				when we moved the emphasis away from klines to glines -myr */

	fd = open(filename, O_RDWR|O_APPEND|O_CREAT, 0660);
	if (fd == -1)
	{
		send_prefix_to_client(meptr, pptr,
			"NOTICE %s :Problem opening \"%s\" to write new kline",
			pptr->name, filename);
	}
	else
	{
		static char *_start = "deny { \n\tcomment \"";

		write(fd, _start, strlen(_start));
		write(fd, buffer, strlen(buffer));
		write(fd, "\";\n", 3);

		sprintf(buffer, "\n\tusername \"%s\";\n", user);
		write(fd, buffer, strlen(buffer));
		if (ip_or_host)
			sprintf(buffer, "\thostname \"%s\";\n", host);
		else
			sprintf(buffer, "\tipaddr \"%s\";\n", host);
		write(fd, buffer, strlen(buffer));
		if (expires != -1)
		{
			sprintf(buffer, "\texpire %i;\n", expires);
			write(fd, buffer, strlen(buffer));
		}
		sprintf(buffer, "\treason \"%s\";\n", _reason_fix(reason));
		write(fd, buffer, strlen(buffer));
		if (write(fd, "};\n\n", 4) != 4)
		{
			if (MyClient(pptr))
			{
				send_prefix_to_client(meptr, pptr,
					"NOTICE %s :Problem writing to \"%s\"",
					pptr->name, filename);
			}
		}
		else
			failed = 0;
		close(fd);
	}

	if (ip_or_host)
		ret = access_add(&(_ircd_conf.deny), user, host, NULL,
			NULL, reason, expires, 0, 0, NULL, buffer, NULL, NULL, 0);
	else
		ret = access_add(&(_ircd_conf.deny), user, NULL, host,
			NULL, reason, expires, 0, 0, NULL, buffer, NULL, NULL, 0);

	if (ret)
	{
		if (MyClient(pptr))
			send_prefix_to_client(meptr, pptr,
				"NOTICE %s :Adding of K-Line to memory failed: %i", pptr->name, ret);
	}
	else
	{
		Rehashed = 1;
		if (MyClient(pptr) || IsServer(pptr))
			send_to_opers("%s added K-Line for [%s@%s]%s%s: %s",
				pptr->name, user, host,
				(expires == -1) ? "" : " expiring at ",
				(expires == -1) ? "" : support_ctime(expires),
				reason);
		else if (IsClient(pptr)) /* should always be true */
			send_to_opers("%s from %s added K-Line for [%s@%s]%s%s: %s",
				pptr->name, pptr->servername, user, host,
				(expires == -1) ? "" : " expiring at ",
				(expires == -1) ? "" : support_ctime(expires),
				reason);
	}

	if (!failed)
		send_prefix_to_client(meptr, pptr,
			"NOTICE %s :Added K-Line [%s@%s] to configfile",
			pptr->name, user, host);

	return 3;
}

int m_unkline(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	char			*mask;
	IRCD_CLIENT		*acptr;
	char			*user;
	char			*host = NULL;
	static char		_star[] = "*";
	CONFHOSTIPENTRY	*chentry;
	CONFHOSTIPENTRY	*nextchentry;
	CONFIGFILE		*cfptr;
	CONFIGFILE		*cfp;
	CONFIGENTRY		*ce;
	CONFIGENTRY		*ce2;
	char			*username;
	char			*hostname;
	char			*ipstring;
	char			*mmaparea;
	struct stat		sb;
	int				numfound1;
	int				numfound;
	int				exact = 0;
	int				fd;
	struct _tempstuff
	{
		int		startpos;
		int		len;
		struct _tempstuff *next;
	} *tempstuff, *tptr, *nexttptr;

	tempstuff = NULL;

	if (!IsAnOper(pptr) && !IsServer(pptr))
	{
		send_prefix_to_client(meptr, pptr,
			IRCD_REPLY(ERR_NOPRIVILEGES, pptr->name));
		return 3;
	}

	if (MyClient(pptr) && !(pptr->c_oline_flags & OLINE_FLAGS_CANKLINE))
	{
		send_prefix_to_client(meptr, pptr,
			"NOTICE %s :You are not allowed to UNKLINE", pptr->name);
		return 3;
	}

	if (IsServer(lptr))
		return 3;

	mask = ircd_nextarg(&args, 0);

	if (!mask || !*mask)
	{
		if (IsClient(pptr))
			send_prefix_to_client(meptr, pptr, IRCD_REPLY(ERR_NEEDMOREPARAMS,
				pptr->name), "UNKLINE");
		return 3;
	}
	acptr = hash_find_client(mask);
	if (!acptr || IsServer(acptr))
	{
		user = host = mask;
		while(*host && (*host != '@'))
				host++;
		if (!*host)
		{
			host = mask;
			user = _star;
		}
		else
		{
			*host++ = '\0';
			if (!*host)
				host = _star;
		}
		if (!*user)
			user = _star;
	}
	else
	{
		user = acptr->username;
		host = acptr->hostname;
	}

	numfound = 0;
	for(chentry=_ircd_conf.deny.conf_all;chentry;chentry=nextchentry)
	{
		nextchentry = chentry->ch_next;
		if (chentry->username &&
				!strcmp(chentry->username, user) &&
			((chentry->hostname && !strcmp(chentry->hostname, host)) ||
				(chentry->ipstring && !strcmp(chentry->ipstring, host))))
		{
			numfound++;
			exact = 1;
			break;
		}
		if (chentry->username &&
					match(chentry->username, user) &&
					match(user, chentry->username))
			continue;
		if (!(((chentry->ipstring &&
				(!match(chentry->ipstring, host) ||
						!match(host, chentry->ipstring))) ||
				(chentry->hostname &&
				(!match(chentry->hostname, host) ||
						!match(host, chentry->hostname))))))
			continue;
		numfound++;
	}

	if (numfound > MAXUNKLINES)
	{
		send_prefix_to_client(meptr, pptr,
			"NOTICE %s :Too many bans matched", pptr->name);
		return 3;
	}

	numfound1 = 0;
	for(chentry=_ircd_conf.deny.conf_all;chentry;chentry=nextchentry)
	{
		nextchentry = chentry->ch_next;
		if (exact)
		{
			if (chentry->username &&
				!strcmp(chentry->username, user) &&
			((chentry->hostname && !strcmp(chentry->hostname, host)) ||
				(chentry->ipstring && !strcmp(chentry->ipstring, host))))
			{
				numfound1++;
				access_del(&_ircd_conf.deny, chentry, 0);
			}
			continue;
		}
		if (chentry->username &&
					match(chentry->username, user) &&
					match(user, chentry->username))
			continue;
		if (!(((chentry->ipstring &&
				(!match(chentry->ipstring, host) ||
						!match(host, chentry->ipstring))) ||
				(chentry->hostname &&
				(!match(chentry->hostname, host) ||
						!match(host, chentry->hostname))))))
			continue;
		numfound1++;
		access_del(&_ircd_conf.deny, chentry, 0);
	}

	if (numfound1)
	{
		if (exact)
			send_to_opers("%s removed %i K-Line%s from memory with exact match of %s@%s",
				pptr->name, numfound1, numfound1 == 1 ? "" : "s", user, host);
		else
			send_to_opers("%s removed %i K-Line%s from memory that match%s %s@%s",
				pptr->name, numfound1, numfound1 == 1 ? "" : "s",
				numfound1 == 1 ? "es" : "", user, host);
	}

	cfptr = cfp = config_load(Conffile);

	if (!cfptr)
	{
		send_prefix_to_client(meptr, pptr,
			"NOTICE %s :%d ban%s removed from memory",
			pptr->name, numfound1, numfound1 == 1 ? "" : "s");
		send_prefix_to_client(meptr, pptr,
			"NOTICE %s :Couldn't figure out .conf files to check",
			pptr->name);
		return 3;
	}

	numfound = 0;

    for(;cfptr;cfptr=cfptr->cf_next)
	{
		fd = open(cfptr->cf_filename, O_RDWR);
		if (fd < 0)
			continue;

		if (fstat(fd,  &sb) == -1)
		{
			close(fd);
			continue;
		}

		mmaparea = (char *)mmap(NULL, sb.st_size+1, PROT_READ|PROT_WRITE,
				MAP_SHARED, fd, 0);

		if (mmaparea == (char *)-1)
		{
			close(fd);
			continue;
		}

		tempstuff = NULL;

		for(ce=cfptr->cf_entries;ce;ce=ce->ce_next)
		{
			if (!ce->ce_varname)
				continue;
			if (strcasecmp("deny", ce->ce_varname))
				continue;

			username = hostname = ipstring = NULL;

			for(ce2=ce->ce_entries;ce2;ce2=ce2->ce_next)
			{
				if (!ce2->ce_varname ||
						!ce2->ce_vardata || !*ce2->ce_vardata)
					continue;
				if (!strcasecmp(ce2->ce_varname, "hostname"))
					hostname = ce2->ce_vardata;
				if (!strcasecmp(ce2->ce_varname, "username"))
					username = ce2->ce_vardata;
				if (!strcasecmp(ce2->ce_varname, "ipaddr"))
					ipstring = ce2->ce_vardata;
			}

			if (exact && !(username && !strcmp(username, user) &&
				((hostname && !strcmp(hostname, host)) ||
					(ipstring && !strcmp(ipstring, host)))))
				continue;

			if (username &&
					match(username, user) &&
					match(user, username))
				continue;
			if (!(((ipstring &&
					(!match(ipstring, host) ||
							!match(host, ipstring))) ||
				(hostname &&
					(!match(hostname, host) ||
						!match(host, hostname))))))
				continue;

			if (ce->ce_fileposend <= ce->ce_fileposstart)
			{
				/* sanity */
				continue;
			}

			if (ce->ce_fileposend >= sb.st_size)
				continue;

			if (strncasecmp(mmaparea+ce->ce_fileposstart, "deny", 4)
					|| (mmaparea[ce->ce_fileposend] != ';')) /* odd */
				continue;

			numfound++;

			tptr = (struct _tempstuff *)MyMalloc(sizeof(struct _tempstuff));
			tptr->startpos = ce->ce_fileposstart;
			tptr->len = ce->ce_fileposend - ce->ce_fileposstart + 1;

			while(mmaparea[ce->ce_fileposstart + tptr->len ] == '\n')
				tptr->len++;

			tptr->next = tempstuff;
			tempstuff = tptr;
		}

		if (tempstuff)
		{
			int todelete = 0;

			for(tptr=tempstuff;tptr;tptr=nexttptr)
			{
				nexttptr = tptr->next;

				if (sb.st_size - (tptr->startpos+tptr->len))
					BCOPY(mmaparea + tptr->startpos + tptr->len,
						mmaparea + tptr->startpos,
						sb.st_size - (tptr->startpos + tptr->len));

				todelete += tptr->len;

				MyFree(tptr);

			}

			ftruncate(fd, sb.st_size - todelete);

		}

		if (mmaparea != (char *)-1)
			munmap((void *)mmaparea, sb.st_size+1);
		close(fd);
	}

	config_free(cfp);

	if (numfound)
	{
		if (exact)
			send_to_opers("%s removed %i K-Line%s from disk with exact match of %s@%s",
				pptr->name, numfound, numfound == 1 ? "" : "s", user, host);
		else
			send_to_opers("%s removed %i K-Line%s from disk that match%s %s@%s",
				pptr->name, numfound, numfound == 1 ? "" : "s",
				numfound == 1 ? "es" : "", user, host);
	}

	send_prefix_to_client(meptr, pptr,
		"NOTICE %s :%d ban%s removed from memory and %d from .conf files",
		pptr->name, numfound1, numfound1 == 1 ? "" : "s", numfound);

	return 3;
}
#endif

static void _sendnick(IRCD_CLIENT *cptr, IRCD_CLIENT *acptr)
{
        static  char    ubuf[64];

        if (IsReg(acptr))
        {
                _umode_build(acptr, ubuf, SEND_UMODES);
                send_to_client(cptr, "NICK %s %d %ld %s %s %s %s :%s",
                        acptr->name, acptr->c_hopcount + 1, acptr->c_creation, ubuf,
                        acptr->username, acptr->hostname,
                        acptr->servername, acptr->ircname);
    }
}

#if 0 /* in user.c(?!) */
int m_note(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	return 3;
}

int m_service(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	return 3;
}

int m_squery(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	return 3;
}

int m_servlist(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	return 3;
}

int m_servset(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	return 3;
}

int m_queue(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	char		*command = ircd_nextarg(&args, 0);

	if (IsServer(lptr))
		return 3;

	if (!IsReg(pptr))
	{
		send_prefix_to_client(meptr, pptr, IRCD_REPLY(ERR_NOTREGISTERED, NULL));
		return 3;
	}

	if (!IsAnOper(lptr))
	{
		send_prefix_to_client(meptr, pptr,
			IRCD_REPLY(ERR_NOPRIVILEGES, pptr->name));
		return 3;
	}

	if (!command || !*command)
	{
		int	queue_size;
		int	queue_fl_size;
		int queue_malloced_size;

		queue_get_stats(&queue_size, &queue_fl_size, &queue_malloced_size);
		send_prefix_to_client(meptr, pptr, "NOTICE %s :Queue space in use: %i out of %i allocated",
				pptr->name, queue_size, queue_malloced_size - queue_fl_size);
		send_prefix_to_client(meptr, pptr, "NOTICE %s :Queue space in freelist: %i",
				pptr->name, queue_fl_size);
		return 3;
	}

	if (!strcasecmp(command, "flush"))
	{
		queue_cleanup();
		send_prefix_to_client(meptr, pptr, "NOTICE %s :Queues flushed.",
				pptr->name);
	}
	else
		send_prefix_to_client(meptr, pptr, "NOTICE %s :Unknown queue command.",
				pptr->name);

	return 3;
}

int m_iphash(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	return iphash_command(lptr, pptr, args);
}

int m_rejecthold(IRCD_CLIENT *lptr, IRCD_CLIENT *pptr, char *prefix, char *args)
{
	IRCD_REJECTHOLD	*rptr;
	int				num = (int)vars_value_get_bynum(IRCD_VAR_REJECT_HOLD);

	if (IsServer(lptr))
		return 3;

	if (!IsReg(pptr))
	{
		send_prefix_to_client(meptr, pptr, IRCD_REPLY(ERR_NOTREGISTERED, NULL));
		return 3;
	}

	if (!IsAnOper(lptr))
	{
		send_prefix_to_client(meptr, pptr,
			IRCD_REPLY(ERR_NOPRIVILEGES, pptr->name));
		return 3;
	}

	if ((rptr = Rejectholds) != NULL)
	{
		for(;rptr;rptr=rptr->rh_next)
		{
			ircd_uint32_t nipaddr = htonl(rptr->rh_rem_ipaddr);
			int e = (num <= 0) ? -1 : rptr->rh_firsttime - Now + num;

			if (e > 0)
				send_prefix_to_client(meptr, pptr, "NOTICE %s :%s put on hold %i second%s ago.  Expires in %i second%s.",
					pptr->name, inet_ntoa(*((struct in_addr *)&nipaddr)),
					Now - rptr->rh_firsttime, Now - rptr->rh_firsttime == 1 ? "" : "s",
					e, e == 1 ? "" : "s");
			else
				send_prefix_to_client(meptr, pptr, "NOTICE %s :%s put on hold %i second%s ago.  Entry expired.",
					pptr->name, inet_ntoa(*((struct in_addr *)&nipaddr)),
					Now - rptr->rh_firsttime, Now - rptr->rh_firsttime == 1 ? "" : "s");
		}
	}
	else
		send_prefix_to_client(meptr, pptr, "NOTICE %s :There are currently no IPs on REJECT_HOLD", pptr->name);
	return 3;
}
#endif
