#ifndef __IRCD_CONFIG_H__
#define __IRCD_CONFIG_H__

#define QUEUE_SIZE	1024

#define QUEUEINIT_FLAGS	IQUEUE_FLAGS_USEMMAP

/* SERVICES_SERVER
 * set this to the default server your services will reside on, it can be
 * changed at any time through /quote set services_server services.blah.net by
 * a local or network admin */
/* *** currently does nothing, will be usefull in the future */
#define SERVICES_SERVER "services.hashmark.net"

/* NO_HUB
 * this removes the server's ability to dynamically become a hub.. doesnt really
 * save any resources, just prevents the change; usefull on servers with 
 * little bandwith 
 */
#undef NO_HUB

/* TS5 */
#define TS5

/* TS5_ONLY
 * define this to disallow non-TS5 servers(ts3, usually) from connecting *LOCALLY* (they can connect through another server, just not this one;
 * remember: most irc services are still just TS3 if you decide to define this(only one server on the net
 * need be linked to services, though */
#undef TS5_ONLY

/* DEBUG_MSGS
 * spams the opers with extra notices. you probably dont want this, but whatever floats your boat...
 */
#undef DEBUG_MSGS

/* SYSLOG_RELOADS
 * uses syslogd to note whenever ircd.conf/ircd.so is rehashed/reloaded, USE THIS!
 */
#define SYSLOG_RELOADS

/* KLINES
 * with the invention of G-Lines, KLINES are no-longer necessary. define this if you really want it,
 * although most networks will have no usage for this..
 *
 * defining this will bring back /kline /unkline and the 'hostname' section in deny{}, as well as a little note in numeric 005
 */
#undef KLINES

#ifdef KLINES
#define	MAXUNKLINES	20
#endif

/* HMC 
 * aka `hostmask classing'
 * this appends a users 'status' in front of their username. most people dont want it, 
 * leave this undefined, it may not even work in the future, as the code changes.. */
#undef HMC

/* GLINE_COUNT_CHECKING
 * big issues here; currently this doesnt work. keep it undefined.. */
#undef GLINE_COUNT_CHECKING

/* vars */
/* **** DO NOT UNDEFINE ANY OF THESE ****
 * each one of these settings is changeable in the ircd.conf or through a
 * /quote set whilst the server is running. its all about control. */
#define DEFAULT_NETWORK_HOST			"irc.hashmark.net" 		/* needs to be a valid hostname */
#define DEFAULT_NETWORK_NAME			"hashmarkNETWORK"
#define DEFAULT_MAX_GLINESEARCH			200				/* how many /quote gline = results by default */
#define DEFAULT_ISOPERSTRING			"is an IRC Operator"
#define DEFAULT_RESTRICT_INFO			1				/* not done yet(as of 12/15/01) -myr */
#define DEFAULT_IGNORE_REDUNDANT_MODES		1
#define DEFAULT_SHOW_CLIENTCOUNTER		1
#define DEFAULT_WARN_CHANNEL_DENY		1				/* a variable that controls whether or not an oper is warned when they
										   /deny #chan
										   and the channel name includes a '*' or '?' (those dont apply in channel denies, but they
										   *do* apply in the conf) */
#define DEFAULT_SHOW_GLINE_MSGS			1 				/* show notices to ppl who are glined on 
										 * why(if set to 0, just drops 'em) */
#define DEFAULT_SET_DEFAULTCMODES		1
#define DEFAULT_SHOW_GLINE_EXPIRES		0				/* sends a wallops to opers when glines expire. (its kinda spammy) */
#define DEFAULT_SHOW_FLAGS_NOTICE		0				/* sends a purdy notice to connecting users on how /flags works */
#define DEFAULT_ABUSE_EMAIL			"abuse@hashmark.net"		/* gives this email addy to banned users */
#define DEFAULT_HUB_STATUS			0 				/* whether or not it starts up as a HUB by default */
#define DEFAULT_HIDE_CHANQUIETS			0
#define DEFAULT_HIDE_CHANEXCEPTS		1
#define DEFAULT_HIDE_CHANBANS			1
#define DEFAULT_SET_LEVEL_NOTICE		0				/* whether or not the person gets a "your set level is: %i"
										 * notice when they /oper up */
	/* this will have most or all of the vars in the future */

/************************************************************************
  	Don't change these unless you know what you are doing. 	
*************************************************************************/

#define TOPICLEN    		120
#define QUITLEN			120
#define AWAYLEN			120
#define KILLLEN			120

#define MAXBANS             	80		/* maximum bans, excepts, and quiets on a room; you may set these numbers to */
#define MAXEXCEPTS		MAXBANS		/* other things but its generally considered logical to keep them all the same */
#define MAXQUIETS		MAXBANS

#define MAXCHANNELSPERUSER  30		/* maximum that the SET variable will allow */
#define MAXCLASSNAME        20		/* max size of a class name */

/** never change this. **/
#ifdef NO_HUB
#define DEFAULT_HUB_STATUS 0
#endif

/* idiot check. undefine this, and, well, you might be an idiot. */
#define CANT_RUN_IRCD_AS_ROOT

#endif
