/*
**   IRC - Internet Relay Chat, source/hmc.c
**   Copyright (C) 2001 Adam Loghry
**
**   This program is free software; you can redistribute it and/or modify
**   it under the terms of the GNU General Public License as published by
**   the Free Software Foundation; either version 1, or (at your option)
**   any later version.
**
**   This program is distributed in the hope that it will be useful,
**   but WITHOUT ANY WARRANTY; without even the implied warranty of
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**   GNU General Public License for more details.
**
**   You should have received a copy of the GNU General Public License
**   along with this program; if not, write to the Free Software
**   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* *** this file is not touched unless you #define HMC *** */

#ifdef HMC
#include "ircd_includes.h"

RCSID("$Id: hmc.c,v 1.1.1.1 2001/12/18 07:39:37 myr Exp $");

/* okay..
 *
 * user sets mode +oN
 * server sets *pptr->username to N
 * server propogates mode change as :user MODE user +oN !N
 * 
 * this is the function called only by m_mode() and during logon to set those userflags ON LOCAL CLIENTS
 * each server is responsible for setting their own hosts.. really dangerous for desyncs here, sigh 
 */
#if 0 
void set_ircd_class_byhmc(IRCD_CLIENT *pptr, int hmc)
{
	return 3; /* do we really need such a function? */
}
#endif

/* set_ircd_class_byletter(pptr, "N") */
void set_hmc_byletter(IRCD_CLIENT *pptr, char *letter)
{
	char		old[USERLEN+1];
	char		tmp[USERLEN+1];

	if(pptr->username[1] == '+')
	{
		pptr->username[0] = *letter;
	}
	else
	{
		/* THIS MAY OR MAY NOT WORK, WILL POSSIBLY FUCK THINGS UP.
		 * on a sane environment, every user is formed with a U+ in their host..
		 * we should never get here. */
		strcpy(old, pptr->username);
		strcpy(tmp, letter);
		strcat(tmp, "+");
		strcat(tmp, old);
		support_strncpy(pptr->username, tmp, sizeof(pptr->username)-2); 
	}
}

/* order is .. D -> N -> L -> O -> R -> U */
char *hmc_decide(IRCD_CLIENT *pptr)
{
	if(IsDeaf(pptr))
		return "D";
	else if(IsNetAdmin(pptr))
		return "N";
	else if(IsLocalAdmin(pptr))
		return "L";
	else if(IsAnOper(pptr))
		return "O";
	else if(IsRegistered(pptr))
		return "R";
	else 
		return "U";
}

void set_hmc(IRCD_CLIENT *pptr)
{
	set_hmc_byletter(pptr, hmc_decide(pptr));
}

/* sent here from m_umode() when i recieve a mode from a client
 * not on my server with last parameter of !something
 *
 * :myr MODE myr +oN !N
 *
 * biggest difference is that it performs error checking here, so the other server
 * cant set users hosts to whatever character they want */
void set_hmc_remote(IRCD_CLIENT *pptr, char *hmc)
{
#if 0
	extern	IRCD_HMCLASS	_hostmask_classes[];
	IRCD_HMCLASS		*hptr;
	int	x		= 0;

	for(hptr=_hostmask_classes;hptr;hptr+=2)
		if(!strncmp(hptr->letter, hmc, 1))
			x = 1;

	if(!x)
		return; /* other server sent us a bad flag, bastards.. */
	else
#endif
		set_hmc_byletter(pptr, hmc);

	return;
}
#endif
